{
******************************************************************
*                                                                *
*                                                                *
*                                                                *
*                                                                *
*    * *  L E A S T - S Q U A R E S   P R O C E S S O R  * *     *
*                                                                *
*                                                                *
*                                                                *
*         ---   GLOBAL VARIABLES DEFINITIONS FILE   ---          *
*                                                                *
*                                                                *
*       by :                                                     *
*                                                                *
*           P. Wolfers                                           *
*               c.n.r.s.                                         *
*               Laboratoire de Cristallographie                  *
*               B.P.  166 X   38042  Grenoble Cedex              *
*                                       FRANCE.                  *
*                                                                *
******************************************************************
}


{  Version 1.2-B (or Upper)  of  L S Q  System  }
{************    CPAS  Version   ***************}
{
        *** modification(s) from major version ***


			----

		       nothing

			----

}

%include 'lispsrc:lsq_type_env';   { Get the Lesat-Squares Types Definitions }


[global] var

  { Identifier Attribute Pointer for Varbl and Param list }
  fit_noendcycle,             { Flag to disable the final cycle }
  fit_correl_set,             { Flag to validate the parameter sigma c. }
  fit_correlation,            { Flag to build the correlation matrix }
  fit_stop,                   { Flag to flag fit stop on error }
  fit_setbmatrix,             { Flag to one unique matrixcomputing }
  fit_bmatrix:     boolean;   { Flag for matrix computing }

  fit_fixedvarblblk,          { Diagonal Block of the Fixed Variables }

  fit_blkfirst,               { First and Last Diagonal Block Pointers }
  fit_blklast,
  fit_varfirst,               { First and Last defined Variable Pointers }
  fit_varlast,
  fit_parfirst,               { First and Last Defined Parameter }
  fit_parlast,
  fit_listfirst,              { First and Last Defined List }
  fit_listlast,
  fit_collfirst,              { First and Last Data Collection }
  fit_colllast,
  fit_fitvparm,               { Final Fitting Dependant Directives }
  fit_cyclvparm,              { Cycle Dependant Directives }
  fit_cyclstparm,             { Cycle Init Directives and Parameters }
  fit_cyclstdir,
  fit_fitdir,                 { Final Fitting Dependant Directives }
  fit_cycldir,                { Cycle Dependant Directives }
  fit_idxfirst,               { Existing Loop Index Record List }
  fit_idxlast,
  fit_limfirst,               { Existing Limits Record List }
  fit_limlast,
  opened_diablk: lsq_ptr := nil;  { Opened Diagonal Block }

  fit_maxsing,                { Maximum Number of Allowed Singularities }
  fit_ncycle,                 { Current Cycle Number }
  fit_nvarbl: integer := 0;   { Number of Fitted (free) Variables }

  fit_statis:  statis_ptr := nil;   { Main Fit Statistic Pointer }

  fit_mindiag: lsq_real := 0.0;     { Minimum Correct Value for a Pivot }

  top_case,                   { Top Case Position in the Stack }
  stkp: stkp_typ;             { The Stack Pointer }
  stk: array[1..stack_max] of eqv_type; { Stack Array }
  tree:        eqv_type;      { The Root of Tree }

  define_current: 0..define_max;  { Definition Value }
  define_scope: array[1..define_max] of define_rec; { Definition Scope }

{  * End Of Constants, Types, global variables and procedures definition file  * }
