;(include "lisp_lib.lisp_lib")


(de insymbol ()
  (setq *symb (read)
        *undef sys$_undef
        *kind  sys$_readk)
)



(setq fatalerr ())



(setq pi 3.1416 r 2.0)

(progn

  ; *** use expression ***

  (pragma "T+" "C+")

  (setq eof ())
  (chaine)
  (input () "EXPR>" "P")
  (insymbol)
  (print *symb *undef *kind)
  (until eof
     (print *symb *undef *kind)
     (insymbol)
;    (setq res (expression))
;    (print " = " res ";")
  )
)
;
;  make a case in lisp program.
;
; syntaxe :
;
;;
;;  (case <expression> (
;;    (<label_liste> <statement_list>)    ; <label_list must be integer values.
;;     .....
;;   [ (otherwise  <statement_list>) ]    ; optional otherwise.
;;   ))
;;
;
;
; executable function part.
;
(df case_proceed (case_expr case_min case_max case_table case_other)

  ())
)
(dma case
  ( (otherwise ())                        ; save old otherwise handling.
    (case_expr (read))                    ; get case expression.
    (case_block  (read))                  ; get case body.
    (case_def ())
    (case_entry ())
    (case_label ())
    (case_min ())
    (case_max ())
    (case_dim 0)
    (case_curr 0)
    (case_tabl ())                        ; to allocate a temporary table.
  )
  ;
  ; begin of first scan.
  ;
  (setq case_def case_block)
  {case_scan_1
  (brkunl case_def case_scan_1)

    (setq case_entry (nextl case_def))    ; get a case entry.
    (setq case_label (nextl case_entry))  ; get first label in this entry.

  (brkwh (eq case_label 'otherwise) case_scan_1)

    ; normal case entry.
    (while case_label
      ; get the value of this label and replace it.
      (setq case_curr (car (rplaca case_label (eval (car case_label)))))
      (nextl case_label)                  ; skip to next label.
      (if (null case_min)
        (setq case_max case_curr
              case_min case_curr)         ; set initial min and max.
        (if (> case_curr case_max)        ; update min and max.
          (setq case_max case_curr)
          (when (< case_min case_curr)
            (setq case_min case_curr))
        ))
      (when ( > (- case_max case_min) 255); on table overflow
        (sys_call 0 "case" 1002 4))       ; generate fatal error.
    )
  }
  ; otherwise entry management.
  (when (or case_label case_def)
    (if (eq case_label 'otherwise)
      (setq otherwise case_entry)         ; save otherwise statements.
      (sys_call 0 "case" 1001 3))         ; generate a severe error.
  )  
  ;
  ; end first scan.
  ;
  (setq case_dim (1+ (- case_max case_min))) ; compute the case size.
  (setq case_table (m_allocb (* 4 case_dim))); allocate the space for the table.
  ; initialize the case table.
  (setq case_entry case_table
        case_curr case_min)
  (until (> case_curr case_max)
    (m_put case_entry M_OB otherwise)
    (setq case_entry (m_offset case_entry 4))
    (1+ case_curr))
  ;
  ; begin of second scan.
  ;
  {case_scan_2
  (brkunl case_block case_scan_2)

    (setq case_entry (nextl case_block))  ; get a case entry.
    (setq case_label (nextl case_entry))  ; get first label in this entry.
    ; here case_entry -> entry body.
  (brkwh (eq case_label 'otherwise))      ; skip otherwise.

    (while case_label
      ; get the value of this label.
      (setq case_curr (m_index case_table 0
                               (- (nextl case_label) case_min))
                               4)         ; get table element pointer.
      (if (eq (m_get case_curr M_OB) otherwise)
        (m_put case_curr M_OB case_entry) ; if label already used,
        (sys_call 0 "case" 1003 3))       ; then severe error.
    )
  }
  ;
  ; generates the scan statement :
  ;   (eval (m_get (m_index <table> 0 4 (- <min> <expr>)) M_OB))
  ;
  (
)
(include "case.mac_lisp" "l+")
(pragma "T+")

(de es (i)
  case i (
    (1 2 4 5) (print " il y a ecole.")
    (3)       (print " musique et ski du mercredi.")
    (6)       (print " samedi : ecole le matin, courses l'apres midi.")
    otherwise (print " *** c'est dimanche ***")
  )
)
(include "tt:")
(setq curve () currpt ())
(progn
  (open 'inp "I" "SYS$INPUT")  ; open the term file as VMS SYS$INPUT.
  (input 'inp)                 ; select terminal input with no prompt.
  (prin " Do you want the centimeter mode [Y/N] ? " )
  (until (> ch " ") (setq ch (readch)))
  (setq cm_flg
    (cond
      ((eq "Y" ch) T)
      ((eq "y" ch) T)
      (T ())
    )
  )
  (print "option = " cm_flg)
  (close 'inp)
  (print)
  (open 'f "i" "curve")
  (input 'f "entrer un point s.v.p. ")
  (setq x (read))                     ; lire x et y d'un point
  (until EOF                          ; jusqu'a la fin du fichier faire...
    (setq y1 (read) y2 (read) y3 (* y1 y1) y4 (* y2 y2))
    (until sys$_read_eoln (read))     ; ignore the end of line.

    (setq cblk (m_allocb 20))         ; allouer un bloc memoire,
    (m_put cblk m_fl x)               ; le rempli avec x et y.
    (m_put (m_offset cblk  4) m_fl y1)
    (m_put (m_offset cblk  8) m_fl y2)
    (m_put (m_offset cblk 12) m_fl y3)
    (m_put (m_offset cblk 16) m_fl y4)
    (if (null curve)                  ; si 1ere point (courbe vide),
      (setq curve (setq currpt        ; initialise la courbe avec ce 1ere point.
        (cons cblk ())))
      (rplacd currpt                  ; sinon
        (cons cblk ()))               ;  ajoute le point a la fin de la courbe.
      (setq currpt (cdr currpt))
    )   ; fin du if.
    (setq x (read))                   ; lire x et y d'un point
  )	; fin du until.
  (close 'f)


;  (print curve)

;  (listing "sys$output")

;  (setq currpt curve)                 ; ; repart du debut de la courbe.
;  (while currpt                       ; ; tant qu'il y a un autre point faire...
;    (setq cblk (nextl currpt))        ; ; prend le bloc memoire courrant,
;                                      ; ;  currpt progresse.
;    (print " X= " (m_get cblk m_fl)   ; ; imprime x et y.
;          ", Y= " (m_get (m_offset cblk 4) m_fl))
;  )  ;	; fin du while.

  ; Init and allocate the plot picture.
  (setq sca (sys_call 201 18.0 30.0 "*Result*" T))

  (setq spc_1 '( 0  4 ()   1))          ; store the curve #1 attributes.
  (setq spc_2 '( 0  8 ()   2))          ; store the curve #1 attributes.
  (setq spc_3 '( 0 12 ()   3))          ; store the curve #1 attributes.
  (setq spc_4 '( 0 16 ()   4))          ; store the curve #1 attributes.

  (setq attr_1 '(1  2  2 10.0))         ; set line, red, dashed, width=10.
  (setq attr_2 '(1  3  3  4.0))         ; set line, blue, dotted, width=4.
  (setq attr_3 '(2  4  4  3.0))         ; set marker, green, circle, size=3.
  (setq attr_4 '(2  7  5  1.0))         ; set marker, magenta, cross, size=1.

  (setq minimaxi_1 (sys_call 250 curve spc_1 curve spc_3)) ; comput the minimaxi for box 1.
  (setq minimaxi_2 (sys_call 250 curve spc_2 curve spc_4)) ; comput the minimaxi for box 2.

  ; fait les 2 boites.
  (setq box_1 (sys_call 251 minimaxi_1  14.0 12.0 2.0  2.0 "Degrees." "Int_A." cm_flg))

  (setq box_2 (sys_call 253))           ; creat a new box.

  (setq box_2 (sys_call 251 minimaxi_2  14.0 12.0 2.0 16.0 "Degrees." "Int_B." cm_flg))

  (sys_call 252 box_1)         ; select box 1.

  (sys_call 202 attr_1)        ; select attribut for the curve 1.
  (sys_call 254 curve spc_1 )  ; plot the curve 1.

  (sys_call 202 attr_3)        ; select attribut for the curve 3.
  (sys_call 254 curve spc_3 )  ; plot the curve 3.

  (sys_call 252 box_2)         ; select box 2.

  (sys_call 202 attr_2)        ; select attribut for the curve 2.
  (sys_call 254 curve spc_2 )  ; plot the curve 2.

  (sys_call 202 attr_4)        ; select attribut for the curve 4.
  (sys_call 254 curve spc_4 )  ; plot the curve 4.

  (sys_call 240)

  (setq menu '("jouer" "danser" "chanter"))

  (print "get_answerd = " (sys_call 221 "Titre" 1 ))

  (sys_call 200)         ; exit from DRAW.

)	; fin du programme

(chaine "TT:")
(setq curve () currpt ())
(progn
  (open 'inp "I" "SYS$INPUT")  ; open the term file as VMS SYS$INPUT.
  ; select terminal input with no prompt.
  (input 'inp " Do you want the centimeter mode [Y/N] ? " )
  (until (> ch " ") (setq ch (readch)))
  (setq cm_flg
    (cond
      ((eq "Y" ch) T)
      ((eq "y" ch) T)
      (T ())
    )
  )
  (print "option = " cm_flg)
  (close 'inp)
  (print)
  (open 'f "i" "curve")
  (input 'f "entrer un point s.v.p. ")
  (setq x (read))                     ; lire x et y d'un point
  (until EOF                          ; jusqu'a la fin du fichier faire...
    (setq y1 (read) y2 (read) y3 (* y1 y1) y4 (* y2 y2))
    (until sys$_read_eoln (read))     ; ignore the end of line.

    (setq cblk (m_allocb 20))         ; allouer un bloc memoire,
    (m_put cblk m_fl x)               ; le rempli avec x et y.
    (m_put (m_offset cblk  4) m_fl y1)
    (m_put (m_offset cblk  8) m_fl y2)
    (m_put (m_offset cblk 12) m_fl y3)
    (m_put (m_offset cblk 16) m_fl y4)
    (if (null curve)                  ; si 1ere point (courbe vide),
      (setq curve (setq currpt        ; initialise la courbe avec ce 1ere point.
        (cons cblk ())))
      (rplacd currpt                  ; sinon
        (cons cblk ()))               ;  ajoute le point a la fin de la courbe.
      (setq currpt (cdr currpt))
    )   ; fin du if.
    (setq x (read))                   ; lire x et y d'un point
  )	; fin du until.
  (close 'f)


;  (print curve)

;  (listing "sys$output")

;  (setq currpt curve)                 ; ; repart du debut de la courbe.
;  (while currpt                       ; ; tant qu'il y a un autre point faire...
;    (setq cblk (nextl currpt))        ; ; prend le bloc memoire courrant,
;                                      ; ;  currpt progresse.
;    (print " X= " (m_get cblk m_fl)   ; ; imprime x et y.
;          ", Y= " (m_get (m_offset cblk 4) m_fl))
;  )  ;	; fin du while.

  ; Init and allocate the plot picture.
  (setq sca (sys_call 201 18.0 30.0 "*Result*" T))

  (setq spc_1 '( 0  4 ()   1))          ; store the curve #1 attributes.
  (setq spc_2 '( 0  8 ()   2))          ; store the curve #1 attributes.
  (setq spc_3 '( 0 12 ()   3))          ; store the curve #1 attributes.
  (setq spc_4 '( 0 16 ()   4))          ; store the curve #1 attributes.

  (setq attr_1 '(1  2  2  3.0))         ; set line, red, dashed, width=3.
  (setq attr_2 '(1  3  3  3.0))         ; set line, blue, dotted, width=3.
  (setq attr_3 '(1  2  3  2.0))         ; set marker, green, circle, size=1.
  (setq attr_4 '(2  7  5  2.0))         ; set marker, magenta, cross, size=2

  (setq minimaxi_1 (sys_call 250 curve spc_1 curve spc_3)) ; comput the minimaxi for box 1.
  (setq minimaxi_2 (sys_call 250 curve spc_2 curve spc_4)) ; comput the minimaxi for box 2.

  ; fait les 2 boites.
  (setq box_1 (sys_call 251 minimaxi_1  14.0 12.0 2.0  2.0 "Degrees." "Int_A." cm_flg))

  (setq box_2 (sys_call 253))           ; creat a new box.

  (setq box_2 (sys_call 251 minimaxi_2  14.0 12.0 2.0 16.0 "Degrees." "Int_B." cm_flg))

  (sys_call 252 box_1)         ; select box 1.

  (sys_call 202 attr_1)        ; select attribut for the curve 1.
  (sys_call 254 0 curve spc_1 )  ; plot the curve 1.

  (sys_call 202 attr_3)        ; select attribut for the curve 3.
  (sys_call 254 0 curve spc_3 )  ; plot the curve 3.

  (sys_call 252 box_2)         ; select box 2.

  (sys_call 202 attr_2)        ; select attribut for the curve 2.
  (sys_call 254 0 curve spc_2 )  ; plot the curve 2.

  (sys_call 202 attr_4)        ; select attribut for the curve 4.
  (sys_call 254 0 curve spc_4 )  ; plot the curve 4.



  (sys_call 241 () (print " rep = " (sys_call 221)))


  (sys_call 240)         ; call DRAW$DIALOG.

  (sys_call 221)         ; call DRAW$GET_ANSWERD.

  (sys_call 200)         ; exit from DRAW.

)	; fin du programme

(chaine "TT:")
(setq curve () currpt ())
(progn
  (open 'inp "I" "SYS$INPUT")  ; open the term file as VMS SYS$INPUT.
  ; select terminal input with no prompt.
  (input 'inp " Do you want the centimeter mode [Y/N] ? " )
  (until (> ch " ") (setq ch (readch)))
  (setq cm_flg
    (cond
      ((eq "Y" ch) T)
      ((eq "y" ch) T)
      (T ())
    )
  )
  (print "option = " cm_flg)
  (close 'inp)
  (print)
  (open 'f "i" "curve")
  (input 'f "entrer un point s.v.p. ")
  (setq x (read))                     ; lire x et y d'un point
  (until EOF                          ; jusqu'a la fin du fichier faire...
    (setq y1 (read) y2 (read) y3 (* y1 y1) y4 (* y2 y2))
    (until sys$_read_eoln (read))     ; ignore the end of line.

    (setq cblk (m_allocb 24))         ; allouer un bloc memoire,
    (m_put cblk m_li 0)               ; met le next = nil.
    (m_put (m_offset cblk  4) m_fl x)               ; le rempli avec x et y.
    (m_put (m_offset cblk  8) m_fl y1)
    (m_put (m_offset cblk 12) m_fl y2)
    (m_put (m_offset cblk 16) m_fl y3)
    (m_put (m_offset cblk 20) m_fl y4)
    (if (null curve)                  ; si 1ere point (courbe vide),
      (setq curve (setq currpt cblk)) ; initialise la courbe avec ce 1ere point.
      (m_put currpt m_ad cblk)        ; sinon
      (setq currpt cblk)              ;  ajoute le point a la fin de la courbe.
    )   ; fin du if.
    (setq x (read))                   ; lire x et y d'un point
  )	; fin du until.
  (close 'f)


;  (print curve)

;  (listing "sys$output")

;  (setq currpt curve)                 ; ; repart du debut de la courbe.
;  (while currpt                       ; ; tant qu'il y a un autre point faire...
;    (setq cblk (nextl currpt))        ; ; prend le bloc memoire courrant,
;                                      ; ;  currpt progresse.
;    (print " X= " (m_get (m_offset cblk 4) m_fl)   ; ; imprime x et y.
;          ", Y= " (m_get (m_offset cblk 8) m_fl))
;  )  ;	; fin du while.

  ; Init and allocate the plot picture.
  (setq sca (sys_call 201 18.0 30.0 "*Result*" T))

  (setq spc_1 '( 4  8 ()   1))          ; store the curve #1 attributes.
  (setq spc_2 '( 4 12 ()   2))          ; store the curve #2 attributes.
  (setq spc_3 '( 4 16 ()   3))          ; store the curve #3 attributes.
  (setq spc_4 '( 4 20 ()   4))          ; store the curve #4 attributes.

  (setq attr_1 '(1  2  2  2.0))         ; set line, red, dashed, width=2.
  (setq attr_2 '(1  3  3  2.0))         ; set line, blue, dotted, width=2.
  (setq attr_3 '(2  4  4  1.0))         ; set marker, green, circle, size=1.
  (setq attr_4 '(2  7  5  4.0))         ; set marker, magenta, cross, size=4.

  (setq minimaxi_1 (sys_call 260 curve spc_1 curve spc_3)) ; comput the minimaxi for box 1.
  (setq minimaxi_2 (sys_call 260 curve spc_2 curve spc_4)) ; comput the minimaxi for box 2.

  ; fait les 2 boites.
  (setq box_1 (sys_call 251 minimaxi_1  14.0 12.0 2.0  2.0 "Degrees." "Int_A." cm_flg))

  (setq box_2 (sys_call 253))           ; creat a new box.

  (setq box_2 (sys_call 251 minimaxi_2  14.0 12.0 2.0 16.0 "Degrees." "Int_B." cm_flg))

  (sys_call 252 box_1)         ; select box 1.

  (sys_call 202 attr_1)        ; select attribut for the curve 1.
  (sys_call 264 curve spc_1 )  ; plot the curve 1.

  (sys_call 202 attr_3)        ; select attribut for the curve 3.
  (sys_call 264 curve spc_3 )  ; plot the curve 3.

  (sys_call 252 box_2)         ; select box 2.

  (sys_call 202 attr_2)        ; select attribut for the curve 2.
  (sys_call 264 curve spc_2 )  ; plot the curve 2.

  (sys_call 202 attr_4)        ; select attribut for the curve 4.
  (sys_call 264 curve spc_4 )  ; plot the curve 4.



  (sys_call 241 () (print " rep = " (sys_call 221)))


  (sys_call 240)         ; call DRAW$DIALOG.

  (sys_call 221)         ; call DRAW$GET_ANSWERD.

  (sys_call 200)         ; exit from DRAW.

)	; fin du programme

(chaine "TT:")
(pragma "R-")
(include "lisp_lib.lisp_lib")


(de insymbol ()
  (setq *symb (read)
        *undef sys$_undef
        *kind  sys$_readk)
)

; identifier is an atom :
;
;   val is the value (for cte Lisp param)
;       or the address (for user objects).
;
;   plist is the related type (int, float, string, other)
;
;   the function body must be () except for function.
;

;
; Procedure to put proceed a reference or an operator.
;
; It use the operational stack opstk.
;
(de putitem (expr)
  (let
    ( (np     (cadr expr))                ; get parameter number.
      (fnc    (nth 4 expr))               ; get function code.
      (parm   ())                         ; initialize each local
      (erflg  ())                         ; ... variables.
      (cmpflg ())                         ;
      (typlst ())                         ;
      (varflg ())                         ;
      (lcall  ())                         ;
    )
    (if (null np)                         ; when it is a reference,
      (setq opstk (cons expr opstk))      ; push it in operational stack,
                                          ; else generate a function call.
      (if (null fnc)                      ; if noop function
        (setq opstk (nthcdr (1- np) opstk));clean the parameters...
        ; *********   else, true function. ****************
        (setq typlst (eval fnc)           ; get the formal type list.
              cmpflg (or (null (plist fnc))  ; and set the kandler byte
                               (getprop fnc '*khandler)))
        (while (>= (decr np) 0)           ; loop on each parameter.
          (setq parm (cddr (nextl opstk))); get the effective parameter.
          (when typlst                    ; if a formal list is defined ...
            ; if the effective type is compatible with the formal ...
            (if (memq (lisp_kind (cadr parm)) (setq varflg (nextl typelst)))
              (setq varflg (car varflg))  ; ... get var as cte flag setting.
              (sys_call 0 "EXPR" 84 3)    ; else Error, incompatible arg.
              (setq erflg T)
            )
          )
          (setq lcall (cons               ; build the parameter list.
            (cond
              ((eq (car parm) '*varbl)    ; variable ref. :
                (unless varflg (setq cmpflg ())) ; flag=>to handle var as cte.
                (caddr parm)              ; return the variable identifier.
              )
              ((eq (car parm) '*expr)     ; expression parameter :
                (setq cmpflg ())          ; clear on line computing flag,
                (caddr parm)              ; and return the Lisp expression.
              )
              (T (cadr parm))             ; constante value : return the value.
            )
            lcall)
          )
        ) ; end of parameter loop.
        ; ******* Proceed the function *************
        (setq opstk (cons
          (if cmpflg                      ; if the function is a cte handler ...
            (list 9 () '*const (apply fnc lcall)) ; comput the result.
            (list 9 () '*expr (nth 3 expr) (cons fnc lcall)); generate Lisp expr.
          )
             opstk)
        )
      )
    )
  )
) ; *** End of PUTITEM function ***




(de getitem ()
  (let
    ((res     '(-1 ())))
    case *kind (
      (0) ; *** List => Operator or Separator ***
        (if (car *symb)                   ; if it is an operator.
          (if bunit                       ; if unary context.
            (unless (setq res (cdr (assq 1 *symb))); get unary op. definition,
              (sys_call 0 "EXPR" 58 3)    ; if not found error,
                                          ; ... unary op. expected.
            )
            (unless (setq res (cdr (assq 2 *symb)); get binary op. definition,
                          bunit T)        ; and set the unary flag.
              (sys_call 0 "EXPR" 58 3)    ; if not found error,
                                          ; ... binary op. expected.
            )
          )
          ; ***** Separator case *****
          (if (eq (cadr *symb) "(")      ; for open parenthesis ...
            (progn                       ; ... then ...
              (insymbol)                 ; Gobble up "("
              (setq res (expression)     ; Get a the sub-expression.
                    bunit ())            ; Disable unary op. flag.
              (unless (eq (cadr *symb) ")"); if not close parenthesis ...
                (sys_call 0 "EXPR" 81 2) ; ")" was expected error.
              )
            )
            (setq bstp T)                ; stop expression processing.
          )
        )

      (1) ; *** Atom => Variable or Parameter ***
        (progn
          (when *undef
            (sys_call 0 "EXPR" 51 3))   ; Undeclared identifier.
          (setq res
            (if (m_block (eval *symb))  ; if it is not a lisp object ...
              (list 9 () '*varbl (getprop *symb '*type) *symb)
              (list 9 () '*const (eval *symb))
            )
                bunit ()                ; disable unary operator.
          )
        )

      (2 3) ; *** User or Standard Function ***
        (let
          ( (np 0)
            (sep  ",")
            (fnc  *symb)
          )
          (insymbol)                    ; Gobble up the function name.
          (when (eq (cadr *symb) "(")
            (while (eq sep ",")
              (insymbol)                ; Gobble up the separator.
              (putitem (expression))    ; push each parameter in opstk.
              (incr np)
              (setq sep (cadr *symb))
            )
            (unless (eq (cadr *symb) ")")
              (sys_call 0 "EXPR" 81 2)  ; else error << ")" expected. >>.
            )
          )
          (setq res (list 9 np '*funct (getprop fnc '*type) fnc)
                bunit ())               ; binary op possible.
        )

      (4  ; *** Nil (or nul string) ***
       5  ; *** True value ***
       6  ; *** Integer cte ***
       7  ; *** Float cte ***
       8  ; *** Character ***
       9) ; *** String ***
        (setq res (list 9 () '*const *symb)
              bunit ())               ; binary op possible.

      otherwise
        ()
    )
    (unless bstp (insymbol))
    res
  )
) ; *** End of Getitem ***



(de expression ()
  (let ((stk   ())
        (opstk ())
        (bunit  T)
        (bstp   ())
        (gtitm  ())
       )
    (setq gtitm (getitem))
    (until (or (and (null stk) bstp) fatalerr)
      (if (and stk
               (or (< (car gtitm) (caar stk))
                   (and (= (car gtitm) (caar stk))
                        (<> (car gtitm) 7)
                   )
               )
          )
        (putitem (nextl stk))          ; pop item from the current.
        (setq stk   (cons gtitm stk)
              gtitm (getitem)
        )
      )
    )
    (when (> (length opstk) 1)
      (sys_call 0 "EXPR" 55 4)         ; operator stack error.
      (setq fataerr T)
    )
    (car opstk) ; send the expression result.
  )
)

(setq fatalerr ())



(progn
  ; *** Define the separators ***
  (sys_call 20 "(" (() "(")) ; Open parenthesis.
  (sys_call 20 ")" (() ")")) ; Close parenthesis.
  (sys_call 20 "," (() ",")) ; Comma.
  (sys_call 20 ";" (() ";")) ; Semicolon.

  ; *** Define the operators ***
  (sys_call 20 ":" (() ":")  ; Colon separator.
               "=" ((2 8 2 () () *assign))) ; assignement operation.

  (sys_call 20 "^" ((2 6 2 () () **)))   ; x ^ y.
  (sys_call 20 "*" ((2 5 2 () ()  *))    ; x Multiply y.
               "*" ((2 6 2 () () **)))   ; x ^ y.
  (sys_call 20 "-" ((1 7 1 () () neg)    ; - x.
                    (2 4 2 () ()  -)))   ; x - y.
  (sys_call 20 "/" ((2 5 2 () 1.0 /)))   ; x / y.
  (sys_call 20 "+" ((2 4 2 () ()  +)))   ; x + y.

  (sys_call 20 "=" ((2 3 2 () T   =)))   ; x = y.
  (sys_call 20 "<" ((2 3 2 () T   <))    ; x < y.
               "=" ((2 3 2 () T  <=))    ; x <= y.
               ">" ((2 3 2 () T  <>)))   ; x <> y.
  (sys_call 20 ">" ((2 3 2 () T   >))    ; x > y.
               "=" ((2 3 2 () T  >=)))   ; x >= y.

  (sys_call 20 "&" ((2 2 2 () T and)))   ; x & y.
  (sys_call 20 "!" ((2 1 2 () T  or)))   ; x ! y.

  (dma 'div () '((2 5 2 () 1 div)))      ; x div y.
  (dma 'rem () '((2 5 2 () 1 div)))      ; x rem y.
  (dma 'and () '((2 2 2 () T and)))      ; x and y.
  (dma 'or  () '((2 1 2 () T  or)))      ; x or y.
  (dma 'not () '((1 3 1 () T null)))     ; not x.


  ; *** Define some user function ***

  (de ord (boolean)
    (if boolean
      1
      0
    )
  )


  ; *** Define a cte parameter ***

  (setq pi 3.14159275)
  (setq e (exp 1))


  ; *** Define a varbl ***

  (setq v1 (m_allocb 24))
  (putprop 'v1 '*type 1.0)




  ; *** use expression ***


  (setq eof ())
  (chaine)
  (input () "EXPR>" "P")
  (insymbol)
  (until eof
    (setq res (expression))
    (print " = " res ";;")
    (insymbol)
  )
)
(pragma "R-")
(include "lisp_lib.lisp_lib")


(de insymbol ()
  (setq *symb (read)
        *undef sys$_undef
        *kind  sys$_readk)
)

; identifier is an atom :
;
;   val is the value (for cte Lisp param)
;       or the address (for user objects).
;
;   plist is the related type (int, float, string, other)
;
;   the function body must be () except for function.
;

;
; Procedure to put proceed a reference or an operator.
;
; It use the operational stack opstk.
;
(de putitem (expr)
  (let
    ( (np     (cadr expr))                ; get parameter number.
      (fnc    (nth 4 expr))               ; get function code.
      (parm   ())                         ; initialize each local
      (erflg  ())                         ; ... variables.
      (cmpflg ())                         ;
      (typlst ())                         ;
      (varflg ())                         ;
      (lcall  ())                         ;
    )
    (if (null np)                         ; when it is a reference,
      (setq opstk (cons expr opstk))      ; push it in operational stack,
                                          ; else generate a function call.
      (if (null fnc)                      ; if noop function
        (setq opstk (nthcdr (1- np) opstk));clean the parameters...
        ; *********   else, true function. ****************
        (setq typlst (eval fnc)           ; get the formal type list.
              cmpflg (or (null (plist fnc))  ; and set the kandler byte
                               (getprop fnc '*khandler)))
        (while (>= (decr np) 0)           ; loop on each parameter.
          (setq parm (cddr (nextl opstk))); get the effective parameter.
          (when typlst                    ; if a formal list is defined ...
            ; if the effective type is compatible with the formal ...
            (if (memq (lisp_kind (cadr parm)) (setq varflg (nextl typelst)))
              (setq varflg (car varflg))  ; ... get var as cte flag setting.
              (sys_call 0 "EXPR" 84 3)    ; else Error, incompatible arg.
              (setq erflg T)
            )
          )
          (setq lcall (cons               ; build the parameter list.
            (cond
              ((eq (car parm) '*varbl)    ; variable ref. :
                (unless varflg (setq cmpflg ())) ; flag=>to handle var as cte.
                (caddr parm)              ; return the variable identifier.
              )
              ((eq (car parm) '*expr)     ; expression parameter :
                (setq cmpflg ())          ; clear on line computing flag,
                (caddr parm)              ; and return the Lisp expression.
              )
              (T (cadr parm))             ; constante value : return the value.
            )
            lcall)
          )
        ) ; end of parameter loop.
        ; ******* Proceed the function *************
        (setq opstk (cons
          (if cmpflg                      ; if the function is a cte handler ...
            (list 9 () '*const (apply fnc lcall)) ; comput the result.
            (list 9 () '*expr (nth 3 expr) (cons fnc lcall)); generate Lisp expr.
          )
             opstk)
        )
      )
    )
  )
) ; *** End of PUTITEM function ***




(de getitem ()
  (let
    ((res     '(-1 ())))
    case *kind (
      (0) ; *** List => Operator or Separator ***
        (if (car *symb)                   ; if it is an operator.
          (if bunit                       ; if unary context.
            (unless (setq res (cdr (assq 1 *symb))); get unary op. definition,
              (sys_call 0 "EXPR" 58 3)    ; if not found error,
                                          ; ... unary op. expected.
            )
            (unless (setq res (cdr (assq 2 *symb)); get binary op. definition,
                          bunit T)        ; and set the unary flag.
              (sys_call 0 "EXPR" 58 3)    ; if not found error,
                                          ; ... binary op. expected.
            )
          )
          ; ***** Separator case *****
          (if (eq (cadr *symb) "(")      ; for open parenthesis ...
            (progn                       ; ... then ...
              (insymbol)                 ; Gobble up "("
              (setq res (expression)     ; Get a the sub-expression.
                    bunit ())            ; Disable unary op. flag.
              (unless (eq (cadr *symb) ")"); if not close parenthesis ...
                (sys_call 0 "EXPR" 81 2) ; ")" was expected error.
              )
            )
            (setq bstp T)                ; stop expression processing.
          )
        )

      (1) ; *** Atom => Variable or Parameter ***
        (progn
          (when *undef
            (sys_call 0 "EXPR" 51 3))   ; Undeclared identifier.
          (setq res
            (if (m_block (eval *symb))  ; if it is not a lisp object ...
              (list 9 () '*varbl (getprop *symb '*type) *symb)
              (list 9 () '*const (eval *symb))
            )
                bunit ()                ; disable unary operator.
          )
        )

      (2 3) ; *** User or Standard Function ***
        (let
          ( (np 0)
            (sep  ",")
            (fnc  *symb)
          )
          (insymbol)                    ; Gobble up the function name.
          (when (eq (cadr *symb) "(")
            (while (eq sep ",")
              (insymbol)                ; Gobble up the separator.
              (putitem (expression))    ; push each parameter in opstk.
              (incr np)
              (setq sep (cadr *symb))
            )
            (unless (eq (cadr *symb) ")")
              (sys_call 0 "EXPR" 81 2)  ; else error << ")" expected. >>.
            )
          )
          (setq res (list 9 np '*funct (getprop fnc '*type) fnc)
                bunit ())               ; binary op possible.
        )

      (4  ; *** Nil (or nul string) ***
       5  ; *** True value ***
       6  ; *** Integer cte ***
       7  ; *** Float cte ***
       8  ; *** Character ***
       9) ; *** String ***
        (setq res (list 9 () '*const *symb)
              bunit ())               ; binary op possible.

      otherwise
        ()
    )
    (unless bstp (insymbol))
    res
  )
) ; *** End of Getitem ***



(de expression ()
  (let ((stk   ())
        (opstk ())
        (bunit  T)
        (bstp   ())
        (gtitm  ())
       )
    (setq gtitm (getitem))
    (until (or (and (null stk) bstp) fatalerr)
      (if (and stk
               (or (< (car gtitm) (caar stk))
                   (and (= (car gtitm) (caar stk))
                        (<> (car gtitm) 7)
                   )
               )
          )
        (putitem (nextl stk))          ; pop item from the current.
        (setq stk   (cons gtitm stk)
              gtitm (getitem)
        )
      )
    )
    (when (> (length opstk) 1)
      (sys_call 0 "EXPR" 55 4)         ; operator stack error.
      (setq fataerr T)
    )
    (car opstk) ; send the expression result.
  )
)

(setq fatalerr ())



(progn
  ; *** Define the separators ***
  (sys_call 20 "(" (() "(")) ; Open parenthesis.
  (sys_call 20 ")" (() ")")) ; Close parenthesis.
  (sys_call 20 "," (() ",")) ; Comma.
  (sys_call 20 ";" (() ";")) ; Semicolon.

  ; *** Define the operators ***
  (sys_call 20 ":" (() ":")  ; Colon separator.
               "=" ((2 8 2 () () *assign))) ; assignement operation.

  (sys_call 20 "^" ((2 6 2 () () **)))   ; x ^ y.
  (sys_call 20 "*" ((2 5 2 () ()  *))    ; x Multiply y.
               "*" ((2 6 2 () () **)))   ; x ^ y.
  (sys_call 20 "-" ((1 7 1 () () neg)    ; - x.
                    (2 4 2 () ()  -)))   ; x - y.
  (sys_call 20 "/" ((2 5 2 () 1.0 /)))   ; x / y.
  (sys_call 20 "+" ((2 4 2 () ()  +)))   ; x + y.

  (sys_call 20 "=" ((2 3 2 () T   =)))   ; x = y.
  (sys_call 20 "<" ((2 3 2 () T   <))    ; x < y.
               "=" ((2 3 2 () T  <=))    ; x <= y.
               ">" ((2 3 2 () T  <>)))   ; x <> y.
  (sys_call 20 ">" ((2 3 2 () T   >))    ; x > y.
               "=" ((2 3 2 () T  >=)))   ; x >= y.

  (sys_call 20 "&" ((2 2 2 () T and)))   ; x & y.
  (sys_call 20 "!" ((2 1 2 () T  or)))   ; x ! y.

  (dma 'div () '((2 5 2 () 1 div)))      ; x div y.
  (dma 'rem () '((2 5 2 () 1 div)))      ; x rem y.
  (dma 'and () '((2 2 2 () T and)))      ; x and y.
  (dma 'or  () '((2 1 2 () T  or)))      ; x or y.
  (dma 'not () '((1 3 1 () T null)))     ; not x.


  ; *** Define some user function ***

  (de ord (boolean)
    (if boolean
      1
      0
    )
  )


  ; *** Define a cte parameter ***

  (setq pi 3.14159275)
  (setq e (exp 1))


  ; *** Define a varbl ***

  (setq v1 (m_allocb 24))
  (putprop 'v1 '*type 1.0)




  ; *** use expression ***


  (setq eof ())
  (chaine)
  (input () "EXPR>" "P")
  (insymbol)
  (until eof
    (setq res (expression))
    (print " = " res ";;")
    (insymbol)
  )
)
(pragma "l-" "r-")
(include "filtre.lisp")

; base de donnees pour ELIZA.
(setq el_data '(
  ( (au revoir)        " bientt." )
  ( ( non )            '("vous tes bien ngatif") )
  ( (&- lisp &-)       '("Comment, vous connaissez ce language!") )
  ( (&- ans &-)        '("remontez plus loin dans vos souvenirs") )
  ( (&- annees &-)     '("cela fait bien longtemps") )
  ( ($-)               '("c'est un peu court") )
  ( (&- je ne suis pas &l) 
               [ "qu'est-ce qui vous fait pensez que vous n'tes pas " l ] )
  ( (&- je ne &-)      '("vous tes sr ?") )
  ( (&- non &-)        '("vous tes bien ngatif") )
  ( (&- suis &l)       [ "pourquoi pensez vous que vous tes " l ] )
  ( (&- vous &-) 
               '("concentrez vous sur votre problme, s'il vous plat") )
  ( (&- moi &-)        '("dites m'en plus sur votre famille") )
  ( (&- je &-)         '("comment cela se manifeste-t-il ?") )
  ( (j quote ai $xx)   [ "il ne faut pas trop avoir " xx ] )
  ( (j quote ai $xx &yy)
                       [ "il est dangereux d'avoir " xx " " yy ] )
  ( (&- j quote ai &-)
                       '("depuis combien de temps ?") )
  ( (&- combien &-)    '("ce n'est point la quantit qui compte") )
  ( ($- $- $-)         '("Hummm") )
  ( (&-)               '("je ne vous suis pas trs bien") )
))

(de ECRIT (L)
   (if (consp L) (mapcar L 'ECRIT) (prin " " L)))

(dmc "." () ".")
; procedure de lecture.
(de READ_LIST ()
  (let ((OBJ (read)))
    (if (consp OBJ) OBJ (cons OBJ ()))
  )
)

(de LIT ()
  (let ((REP (READ_LIST)))
       (until (or (eq 1 (ch_order (peekch)))
                  (eq 0 (ch_order (peekch)))) ; until eol or eof ...
              (nconc REP (READ_LIST)))
       (if (eq 0 (ch_order (peekch))) (fexit "Oh! Alors adieux."))
       REP
  )
)

; le programme.
(de ELIZA ()
  (open 'inp "I" "SYS$INPUT")  ; open the term file as VMS SYS$INPUT.
  (input 'inp "eliza> ")  ; select terminal input with no prompt.
  (output () 79 0)  ; line width set at 79 char. and no page managment.

  (print "bonjour, quel est votre problme ?")
  (while (nequal '(au revoir) (setq USR (LIT)))
         (setq REGLE EL_DATA)
         (until (setq SELECTION (MATCH (car (setq R (nextl REGLE))) USR)) ())
         (setq RES (REFLECHIT (cadr SELECTION) (cadr R)))
         (prin " -> ") (ECRIT RES) (print)
  )
  (print " Au revoir,  bientt.")
  (close 'inp)
)

(de REFLECHIT (ENV MODELE)
	(eval `(LETALL  ENV ,MODELE)))

(eliza)   ; start the program.
(DE ISCONST (X)
	(OR (NULL X) (EQ X T) (NUMBERP X)
		(AND (CONSP X) (EQ (CAR X) 'QUOTE))))

(DE COMBINE-EXPRS (LFT RGT EXPR) (COND
	((AND (ISCONST LFT) (ISCONST RGT)) ['QUOTE EXPR])
	((NULL RGT) ['LIST LFT])
	((AND (CONSP RGT) (EQ (CAR RGT) 'LIST))
		(CONS 'LIST (CONS LFT (CDR RGT))))
	(['CONS LFT RGT])))

(DE BACKQUOTE (EXPR) (COND
	((NULL EXPR) NIL)
	((ATOM EXPR) ['QUOTE EXPR])
	((EQ (CAR EXPR) '*UNQUOTE*) (CADR EXPR))
	((AND (CONSP (CAR EXPR))(EQ (CAAR EXPR) '*SPLICE-UNQUOTE*))
		['APPEND (CADAR EXPR)(BACKQUOTE (CDR EXPR))])
	((COMBINE-EXPRS (BACKQUOTE (CAR EXPR))
		(BACKQUOTE (CDR EXPR)) EXPR))))

(DMC "`" ()
	(LET ((VIRGULE (TYPECH ",")))
		(DMC "," ()
			(LET ((X (PEEKCH)))
				(IF (NEQUAL X "@") ['*UNQUOTE* (READ)]
					(READCH)
					['*SPLICE-UNQUOTE* (READ)]
				)   ; end if.
			)  ; end let
		)   ; and dmc virgule.
		(LET ((QUASI ['BACKQUOTE ['QUOTE (READ)]]))
			(TYPECH "," VIRGULE)
			(EVAL QUASI))
	)
)

(open 'lisp_lisp "W" "LISP_LIS.LIS")
(SETQ LISP_FLAG nil)
(dmc "^" () (cond
		((NULL LISP_FLAG) (SETQ LISP_FLAG T) (OUTPUT 'lisp_lisp))
		( T (SETQ LISP_FLAG NIL) (OUTPUT))))

(CHAINE)
(DE 4-IEME (L) (CAR (CDR (CDR (CDR L )))))
(DE FAC (N) (IF (ZEROP N) 1 (* N (FAC (1- N)))))
(DE REV (L RES)
   (IF (NULL L) RES
       (REV (CDR L) (CONS (CAR L) RES))))
(DE ASK (Q) ((PRIN Q) (PRINFLUSH) (READ)))
(CHAINE)
(DMC "$" () (cons $ (read)))
(chaine)
(de rac2 (n)
   (let ((p 1) (k 0) (n (1- n)))
      (if (< n 0) k
         (self (+ p 2)(+ k 1)(- n (+ 2 p))))))

(de pgcd (m n)
	(let ((x (pgcd1 m n)))
		(if x x (list m 'et n 'sont 'premiers 'entre 'eux))))
(de pgcd1 (m n) (cond
	((> m n) (pgcd1 n m))
        ((= (rem n m) 0)
		(if (= m 1) () m))
	(t (pgcd1 (rem n m) m)) ))

(chaine)
(pragma "R-")
(include "lisp_lib.lisp_lib")


(de insymbol ()
  (setq *symb (read) *kind sys$_readk *undef sys$_undef)
  (if (consp *symb)                 ; List => Operator.
    (setq *operator (cadr *symb) *symb (car *symb))
    (setq *operator ())             ; Not a list => No operator.
  )
)


(de expr_ident ()
  case *kind (
    (1)                             ; atom => identifier.
      (if *undef                    ; when undeclared ...
        (progn
          (sys_call 0 "EXPR" 601 3) ; undeclared identifier error.
          (setq *expr_value *symb
                *expr_type  (())    ; un usable type.
                *expr_attr  '*const)    
        )
        (setq   *expr_attr (getprop *symb '*class) ; get the class.
                *expr_type (getprop *symb '*type)  ; get the type.
                *expr_value (eval *symb)) ; and the value.
      )
    (4)                           ; integer.
      (setq *expr_value *symb
            *expr_type  1
            *expr_attr  '*const)    
    (5)                           ; float.
      (setq *expr_value *symb
            *expr_type  1.0
            *expr_attr  '*const)    
    (0 6 7)                       ; Nil or char or string.
      (setq *expr_value *symb
            *expr_type  "c"
            *expr_attr  '*const)    
    otherwise
     (sys_call 0 "EXPR" 600 4) ; unexpected error.
  )
  (insymbol)
)


(de exp_apply_una (oper p1)            ; Apply an operator function.
   (if (consp p1)                      ; if parameter is a list (expr.)
     (cons oper p1)                    ; create an executable Lisp list.
     (if (m_block p1)                  ; if it is a MXD object ...
       (cons oper p1)                  ; create a list also ...
       (funcall oper p1)               ; else execute it.
     )
   )
)

(de expr_gen_una lope
  (setq oper (nextl lope) npar (nextl lope))
    (if (eq expr_attr '*const)
      (setq expr_value (apply oper exp_value)
            expr_type  (value
  )
)



(de exp_una ()
  (let ( (neg_flg ())
         (expr ())
       )
  (while (memq *operator '(+ -))       ; when unary + or -.
    (when (eq *operator '-)            ; if negate operator then ...
      (setq neg_flg (null neg_flg))    ; switch the negate flag.
    )
    (insymbol)                         ; gobble up the unary operator.
  )
  (if (eq *symb '*lpar*)               ; "(" was seen ?
    (progn
      (setq expr (expression))         ; get the expression.
      (if (eq *symb '*rpar*)
        (insymbol)                     ; Gobble up ")"
        (sys_call 0 "EXPR" 604 2)      ; else error.
      )
    )                             
    (setq expr (exp_ident))            ; get identifier.
  )
  (if neg_flg                          ; if negate ...
    (exp_apply_una 'neg expr () ())    ; ... apply it, else ...
    expr                               ; ... return this expression.
  )
)                                      ; end of exp_una.

(progn
  (sys_call 20 "(" *lpar*)
  (sys_call 20 ")" *rpar*)
  (sys_call 20 ":" *colon*
               "=" *assign*)
  (sys_call 20 ";" *semicolon*)
  (sys_call 20 "," *comma*)

  (sys_call 20 "^" (** **))
  (sys_call 20 "*" (* *) "*" (** **))
  (sys_call 20 "/" (/ *))
  (sys_call 20 "+" (+ +))
  (sys_call 20 "-" (- -))
  (sys_call 20 "<" (< =) "=" (<= =) ">" (<> =))
  (sys_call 20 ">" (> = ) "=" (>= =))
  (sys_call 20 "\" (null null) "=" (<> =))
  (sys_call 20 "&" (and and))
  (sys_call 20 "!" (or or) "!" (concat +))

  (dma 'div () '(div *))
  (dma 'rem () '(rem *))
  (dma 'and () '(and and))
  (dma 'or  () '(or or) )


  (chaine "mxdini")             ; Open the MXD initial file.
  (input () "MXD_V4" "P")       ; set MXD prompt with Pascal comment.

  (insymbol)                    ; Read the first syntax unit.
  (until eof                    ; Until end of file ...

    (statement)                 ; execute/compile statements.

  )

)
sys$_eof ; logical end of file.


  ;     operator    npar  op    res   p1    p2.
  (setq    -      '((1    neg   1     1)
                    (1    neg   1.0   1.0)
                    (2    -     1     1     1)
                    (2    -     1.0   1.0   1.0))
           **     '((2    **    1     1     1)
                    (2    **    1.0   1.0   1.0))
           *      '((2    *     1     1     1)
                    (2    *     1.0   1.0   1.0))
           /      '((2    /     1.0   1.0   1.0))
           +      '((1    ()    1     1)
                    (1    ()    1.0   1.0)
                    (2    +     1     1     1)
                    (2    +     1.0   1.0   1.0))
           <      '((2    <     T     1     1)
                    (2    <     T     1.0   1.0)
                    (2    <     T     "c"   "c"))
           <=     '((2    <=    T     1     1)
                    (2    <=    T     1.0   1.0)
                    (2    <=    T     "c"   "c"))
           <>     '((2    <>    T     1     1)
                    (2    <>    T     1.0   1.0)
                    (2    <>    T     "c"   "c"))
           =      '((2    =     T     1     1)
                    (2    =     T     1.0   1.0)
                    (2    =     T     "c"   "c")))
           >      '((2    >     T     1     1)
                    (2    >     T     1.0   1.0)
                    (2    >     T     "c"   "c"))
           >=     '((2    >=    T     1     1)
                    (2    >=    T     1.0   1.0)
                    (2    >=    T     "c"   "c"))
           null   '((1    null  T     T))
           and    '((2    and   T     T     T))
           or     '((2    or    T     T     T))
           concat '((2   concat "c"   "c"   "c"))
)
                       

  (typech "'" (typech """"))    ; Set quote for string as MXD.


  (dma 'include () (include (read))
  )

  (dma 'chaine () (chaine (read))
  )





  (chaine)
  (input () "DPU>" "P")      ; Set the pascal comment mode.
  (pragma "L+")

  (setq eof ())              ; remove the eof mark.
  (until eof
    (insymbol)
    (print " == " *symb ", " *kind ", " *undef )
  )

)
;
;   ****  Algebraical Expression Manager  ****
;



; get the macro and loop macro definition.
(include "lisp_lib.lisp_lib")

;
;

(de insymbol ()
  (setq symb_val (read)
        symb_kind sys$_readk
        symb_flag sys$_undef
  )
)

;
; Procedure to set expression classe type and value.
;
(de expr_set (l class type val)
  (rplaca l class)
  (nextl l)
  (rplaca l type)
  (nextl l)
  (rplaca val)
)
(setq expr_attr '(1 2 3))

(de expr_set_class (class)
  (rplaca expr_attr class)
)

(de expr_class (l) (car l))

(de expr_set_type (type)
  (rplaca (cdr expr_attr) type)
)

(de expr_type (l) (cadr l))

(de expr_set_value (value)
  (rplaca (cddr expr_attr) value)
)

(de expr_value (l) (caddr l))


;
; definitions table of least-squares object types.
;
(setq expr_types
  (v_create 6 '(variable param list collect diablk limits)
               'unknown))



;
; procedure to set a default value on incompatible operator error.
;
(de expr_correct (op res)
  (setq op (cddr op))
  (rplaca res (cadr op))
  (rplaca (cddr res) 'const)
)

;
; Procedure to apply an unary operator.
;
; The operator is specified as :
;   (<lisp operator> <lisp_funct_test> <modelp1> <modelres>)
;
; The parameter is specified as :
;   (<value> <model> <class>)
;
(de unary_eval (op p1)
  (if (funcall (cadr op) (cadr p1))
    (if (eq caddr p1) 'const)
      (rplaca p1 (funcall (car op) (car p1))   ; constant case => compute.
      (rplaca p1 (cons (car op) (car p1))      ; otherwise built lisp expr.
      (rplaca (caddr p1) 'expression)          ; and set expression mode.
    )                                          ; else
    (sys_call 0 "EXPR" 121 3)                  ; send src error message,
    (expr_correct op p1)                       ; and set model for default.
  )
)

;
; Procedure to apply a binary operator.
;
; The operator is specified as :
;   (<funct_testp1> <funct_testp2> <lisp_operator> <Modelres>)
;
; The parameters are specified as :
;   (<value> <model> <class>)
;
(de binary_eval (op p1 p2)
  (if (and (funcall (nextl op) (cadr p1))
           (funcall (nextl op) (cadr p2))
    (if (eq caddr p1) 'const)
      ; constant case => compute.
      (rplaca p1 (funcall (car op) (car p1) (car p2))
      ; otherwise built lisp expr.
      (rplaca p1 (cons (car op) (car p1))      
      (rplaca (caddr p1) 'expression)          ; and set expression mode.
    )                                          ; else
    (sys_call 0 "EXPR" 121 3)                  ; send src error message,
    (expr_correct op p1)                       ; and set model for default.
  )
)

;
;  Routine to get an expression element.
;
(de expr_object ()
  case symb_kind (
    ( 1 )                                ; * atom case => identifier.
        (if symb_flag
          (sys_call 0 "EXPR" 102 3)      ; ** Undeclared identifier.
          (setq expr_class  (getprop symb_val 'ident_class)
                expr_type   (getprop symb_val 'ident_type)
                expr_value  (eval symb_val)
          )
        )

    ( 4 )                                ; * integer constant.
        (setq expr_class 'const
              expr_type  'integer
              expr_value symb_val)
    ( 5 )                                ; * floatting constant.
        (setq expr_class 'const
              expr_type  'float
              expr_value symb_val)
    ( 0 6 7 )                            ; * nil or character or string.
        (setq expr_class 'const
              expr_type  'string
              expr_value symb_val)        

    otherwise
      (sys_call 0 "EXPR" 101 3)          ; illegal object.
  )
  (expr_set expr_attr expr_class expr_type expr_value)
  (insymbol)
)

;
;  Routine to handle the negate operator.
;
(de expr_negate ()
  (let ( (expr_negated ()))
    (if (eq symb_val '+)
      (insymbol)                                 ; skip + unary operator.
                                                 ; and handle negate operator.
      (when (eq symb_val '-) (setq expr_negated T) (insymbol))
    )
    (if (null (eq symb_val '*lpar*))
      (expr_object)                              ; simple object case.
      (insymbol)                                 ; gobble up the "("
      (expression)                               ; get the expression.
      (if (eq symb_val '*rpar*)                  ; if end by ")"
        (insymbol)                               ; then gobble up it,
        (sys_call 0 "EXPR" 102 2)                ; else send error message.
      )
    )
    (when expr_negated
      (if (eq (expr_class) 'const)
        (expr_set_value (neg (expr_value)))      ; for constant expr. evaluate.
        (expr_set_class 'expression)             ; turn on expression mode.
              expr_value (cons 'neg expr_value)) ; built lisp expression.
      )
      )
  ) ; let end. 
) ; end of expr_negate.


;
;  Routine to handle the power operator.
;
(de expr_power ()
  (let ((expr_first (
  )
)

;
; Expression routine.
;
(de expression ()

)

(progn
  (dmc "(" () '*lpar*)
  (dmc ")" () '*rpar*)
  (dmc "^" () '^)
  (dmc "*" () (if (null (eq (peekch) "*")) '* (readch) '^))
  (dmc "/" () '/)
  (dmc "+" () '+)
  (dmc "-" () '-)
)

;
; Generator/computor of a lisp expression.
;
;
; negate (- unary)  op = (neg neg)
; not (- unary)     op = (*not null)
;
(de expr_geneop (op p1 p2)

)
;
; A general Curve Fitting program.
;
(pragma "R-")                    ; Turn off the result Lisp flag.

;
; Get the Expression manager definitions.
;

(include "lisp_lib.lisp_lib")    ; Include the Case and Loop macros.
(include "lisp_expr.lisp_lib")   ; Include the expression manager.


;
; Define all standard objects.
;

; *** Define some user function ***

(de ord (boolean)
  (if boolean
    1
    0
  )
)


; *** Define a cte parameter ***

(setq pi 3.14159275)
(setq e (exp 1))


; *** Define a varbl ***

(setq v1 (m_allocb 24))
(putprop 'v1 '*type 1.0)




; *********************************
; *                               *
; *   Fit Data Compiler Routine   *
; *                               *
; *********************************

; * Define the Include and Chaine actions *.
(de include_state (incl_flag)
  (let ( (str (cte_str_expr "sys$command")) ; get the filename.
       )
    (unless (eq (cadr *symb) ";")
      (sys_call 0 "INCL" 91 2))
    (if incl_flag
      (progn
        (include str)
        (incr *nincl)
      )
      (chaine str)
    )
    (input () "FIT_V4>" "P")
  )
)

(de eof_state ()
  (unless (<= *nincl 0)         ; For a not final eof ...
    (decr *nincl))
)

(de variable_state ()

)

(de assignement_state (*ide *typ)
  (insymbol)                           ; gobble up the identifier.
  (unless (eq caddr *symb "=")         ; assignement not present ?
    (sys_call 0 "ASSG" 83 2))          ; then error.
  (if (m_block (symeval *ide))         ; if it is a variable/param ?
    (
       
    )
    (set *ide (cte_expression *typ))   ; assign the new value.
  )
)


; *** Routine to handle a statement. ***

(de statement ()
  case *kind (
    (0) ; *** List => Operator, Separator or Keyword ***
      (if (null (nextl *symb))          ; if it is a separator or a keyword
        (if (stringp (car *symb))       ; it is a separator ?
          (progn                        ;
            (unless (eq (car *symb) ";"); if it is not a semicolon then
              (sys_call 0 "STAT" 64 2)) ; send error message.
            (insymbol)                  ; gobble up the separator.
          )
          ; *** No, it is a keyword ***
          (let
            ( (*stat (cdr *symb))       ; Get the statement code.
            )
            (insymbol)                  ; Gobble up the keyword.
            (eval *stat)                ; and perform the statement.
          )
        (sys_call 0 "STAT" 65 3)        ; Illegal construction.
      )

    (1) ; *** User symbol assignement. ***
      (progn
        (when *undef
          (sys_call 0 "STAT" 51 2))     ; Undeclared identifier.
        ; perform an assignement statement.
        (assignement_state *symb (getprop *symb '*type))
      )

    otherwise
      (if eof
        (eof_state)                     ; eof statement.
        (sys_call 0 "STAT" 66 3))       ; Unknown expression.

  )
)   ; *** End of statement routine. ***




; *************************
; *                       *
; *   Fit Data Compiler   *
; *                       *
; *************************

(progn
  (typech "'" (typech """"))             ; Set string delimitor.

  ; *** Define the Keywords ***
  (dma 'include  () '(() include  T ))   ; Include statement.
  (dma 'chaine   () '(() chaine   ()))   ; Chaine statement.
  (dma 'end      () '(() end        ))   ; end keyword.
  (dma 'variable () '(() variable   ))   ; Variable statement.
  (dma 'fixed    () '(() fixed      ))   ; Fixed statement.
  (dma 'unfixed  () '(() unfixed    ))   ; Unfixed statement.
  (dma 'lsqblock () '(() lsqblock   ))   ; Least-squares diagonal block.
  (dma 'param    () '(() param      ))   ; param    statement.
  (dma 'list     () '(() list       ))   ; list     statement.
  (dma 'data     () '(() data       ))   ; data     statement.
  (dma 'load     () '(() load       ))   ; load     statement.
  (dma 'fit      () '(() fit        ))   ; fit      statement.

  ; *** Define the separators ***
  (sys_call 20 "(" (() "("))             ; Open parenthesis.
  (sys_call 20 ")" (() ")"))             ; Close parenthesis.
  (sys_call 20 "," (() ","))             ; Comma.
  (sys_call 20 ";" (() ";"))             ; Semicolon.
  (sys_call 20 ":" (() ":")              ; Colon.
               "=" (() "="))             ; Assignement.

  ; *** Define the operators ***
  (sys_call 20 "^" ((2 7 2 () () **)))   ; x ^ y.
  (sys_call 20 "*" ((2 5 2 () ()  *))    ; x Multiply y.
               "*" ((2 7 2 () () **)))   ; x ^ y.
  (sys_call 20 "-" ((1 8 1 () () neg)    ; - x.
                    (2 4 2 () ()  -)))   ; x - y.
  (sys_call 20 "/" ((2 5 2 () 1.0 /)))   ; x / y.
  (sys_call 20 "+" ((2 4 2 () ()  +)))   ; x + y.

  (sys_call 20 "=" ((2 3 2 () T   =)))   ; x = y.
  (sys_call 20 "<" ((2 3 2 () T   <))    ; x < y.
               "=" ((2 3 2 () T  <=))    ; x <= y.
               ">" ((2 3 2 () T  <>)))   ; x <> y.
  (sys_call 20 ">" ((2 3 2 () T   >))    ; x > y.
               "=" ((2 3 2 () T  >=)))   ; x >= y.

  (sys_call 20 "&" ((2 2 2 () T and)))   ; x & y.
  (sys_call 20 "!" ((2 1 2 () T  or)))   ; x ! y.

  (dma 'div () '((2 5 2 () 1 div)))      ; x div y.
  (dma 'rem () '((2 5 2 () 1 div)))      ; x rem y.
  (dma 'and () '((2 2 2 () T and)))      ; x and y.
  (dma 'or  () '((2 1 2 () T  or)))      ; x or y.
  (dma 'not () '((1 3 1 () T null)))     ; not x.

  ; ******************************
  ; *                            *
  ; *   Fit Data Compiler Main   *
  ; *                            *
  ; ******************************

  (setq
    *nincl 0                             ; set the include count.
    eof ()                               ; Turn off the eof flag.
  )

  (chaine "fit$input")                   ; Open the Fit Source.
  (input () "FIT_V4>" "P")               ; set prompt and pascal comment mode.
  (insymbol)                             ; get the first syntax unit.
  (until (and (zerop incl) eof)          ; Until the final end of file
    (statement)                          ; perform a statement.
  )
  (fexit "Fit Exit")                     ; Exit (End Of Run ).
)
(de fib (n)
	(cond
		((= n 0) 1)
		((= n 1) 1)
		((getprop 'fib n))
		(t
			(putprop 'fib n
				(+ (fib (1- n)) (fib (- n 2))))
			(getprop 'fib n))))
(chaine)

(DE MATCH (FILTRE DONNEE)
  (LET ((ALIST NIL))
    (IF (MATCH-AUX (LINEAR FILTRE) (LINEAR DONNEE))
        (LIST T ALIST) NIL)))

(DE MATCH-AUX (FILTRE DONNEE)
  (LET ((AUX NIL) (ALIST2 NIL))
       (COND
        ((NULL FILTRE)	;test de fin de recursion
         (NULL DONNEE))
        ((AND DONNEE (ATOM DONNEE))	;donnee atomique
         ())	;echec
        ((ATOM (CAR FILTRE))	;constante
         (AND (EQ (CAR FILTRE) (CAR DONNEE))	;si egalite
              (MATCH-AUX (CDR FILTRE) (CDR DONNEE))));on continue, sinon echec

        ((EQUAL (CAAR FILTRE) "#")	;choix multiple
           (LET ((AUX (CDAR FILTRE)) (ALIST2 ALIST))
              (COND
                 ((NULL AUX) (SETQ ALIST ALIST2) NIL)
                 ((MATCH-AUX (APPEND (LINEAR
                                        (CONS (NEXTL AUX) ()))
                                   (CDR FILTRE)) DONNEE) T)
                 (T (SELF AUX ALIST2)))))

        ((EQUAL (CAAR FILTRE) "$")
         (COND	;variable element
                ((NULL DONNEE) ())	;echec
                ((EQ (CDAR FILTRE) '-) (NEXTL-DONNEE)	;pas de aliste
                 (MATCH-AUX (CDR FILTRE) DONNEE))
                ;regardons si la variable a une liaison
                ((SETQ AUX (ASSQ (VAR (CAR FILTRE)) ALIST))	;le doublet
                 (MATCH-AUX
                           (IF (ATOM (CDR AUX))	;a cause de la linearisation
                               (CONS (CDR AUX) (CDR FILTRE))
                               (APPEND (LINEAR (LIST (CDR AUX))) (CDR FILTRE)))
                            DONNEE))
                ;il n'y a pas de liaison, faut creer une nouvelle liaison
                (T (SETQ ALIST (CONS (CONS (VAR (CAR FILTRE)) (NEXTL-DONNEE))
                                ALIST))
                   (IF	;y a-t-il des contraintes
                               (AND (CONSP (CDAR FILTRE)) (CDDAR FILTRE))
         	        ;alors faut les evaluer
                               (IF (EVAL `(LETALL ,ALIST ,@(CDDAR FILTRE)))
                                   (MATCH-AUX (CDR FILTRE) DONNEE);et continuer
                                   (NEXTL ALIST) NIL)		  ;ca marche pas
                               (MATCH-AUX (CDR FILTRE) DONNEE)))));pas de contraintes

        ((EQUAL (CAAR FILTRE) "&")
         (COND	;une variable segment
                ;existe-t-il une valeur
                ((SETQ AUX (ASSQ (VAR (CAR FILTRE)) ALIST));le couple de la alist
                 ;oui, comparer alors la valeur
                 (MATCH-AUX (APPEND (LINEAR (CDR AUX)) (CDR FILTRE)) DONNEE))
                ;c'est la fin du filtre ?
                ((NULL (CDR FILTRE))	;c'est la fin de la donnee
                   ;alors succes
                   (IF (EQ (CDAR FILTRE) '-) ()	;rien a faire si anonyme
                      ;sinon faut creer une liaison
                      (SETQ ALIST (CONS (CONS (VAR (CAR FILTRE))
                                             (DELINEAR-DONNEE)) ALIST)))
                   (IF	;y a-t-il des contraintes ?
                      (AND (CONSP (CDAR FILTRE)) (CDDAR FILTRE))
                      ;si oui faut les evaluer
                      (IF  (EVAL `(LETALL ,ALIST ,@(CDDAR FILTRE))) T
                           (NEXTL ALIST) NIL) ;echec: contrainte non satisfaite
                      T))	;pas de contraintes: tout va bien
                (T  (IF  (SETQ AUX (EQ (CDAR FILTRE) '-)) ();variable anonyme
                              (SETQ ALIST (CONS (LIST (VAR (CAR FILTRE))) ALIST)))
                         (LET ((ALIST2 ALIST));bouclons jusqu'au match du reste
                              (IF DONNEE	;y a encore des donnees
                               ;testons les contraintes
                               (PROGN
                                 (IF (AND (CONSP (CDAR FILTRE)) (CDAR FILTRE))
                                     (IF (EVAL `(LETALL ,ALIST ,@(CDDAR FILTRE)))
                                         ;faisons les comparaisons successives
                                         (SETQ AUX1 (MATCH-AUX (CDR FILTRE) DONNEE))
                                      NIL);echec: contrainte non satisfaite
                                     ;pas de contrainte: continuons
                                     (SETQ AUX1 (MATCH-AUX (CDR FILTRE) DONNEE)))
                                 (IF AUX1 T	;variable anonyme
                                     (SETQ ALIST ALIST2);restaurons la alist
                                     (IF AUX (NEXTL-DONNEE)	;avancons
                                             ;la liaison de la variable s'agrandit
                                             (NCONC (CAR ALIST) (LIST (NEXTL-DONNEE))))
                                     (SELF ALIST)))	;et continuons
                               ;echec total: restaurons la A-liste
                               (IF AUX (NEXTL ALIST))
                               NIL))))))))

(DE VAR (FILTRE)	;pour trouver la variable du filtre
        (IF (ATOM (CDR FILTRE)) (CDR FILTRE) (CADR FILTRE)))

(DE LINEAR (DONNEE)	;pour lineariser
           (COND
             ((ATOM DONNEE)
              DONNEE)
             ((ATOM (CAR DONNEE))
              (CONS (CAR DONNEE) (LINEAR (CDR DONNEE))))
             ((MEMBER (CAAR DONNEE) '("$" "&" "#"))
              (CONS (CAR DONNEE) (LINEAR (CDR DONNEE))))
             (T
              (APPEND (CONS '<< (LINEAR (CAR DONNEE)))
                      (CONS '>> (LINEAR (CDR DONNEE)))))))

(DE DELINEAR (DONNEE)	;pour delineariser
             (IF (ATOM DONNEE) DONNEE
                 (DELINEAR-DONNEE)))

(DE DELINEAR-DONNEE ()	;auxiliaire pour DELINEAR
                    (COND
                      ((ATOM DONNEE)
                       DONNEE)
                      ((EQ (CAR DONNEE) '<<)
                       (NEXTL DONNEE)
                       (CONS (DELINEAR-DONNEE) (DELINEAR-DONNEE)))
                      ((EQ (CAR DONNEE) '>>)
                       (NEXTL DONNEE)
                       ())
                      (T
                       (CONS (NEXTL DONNEE) (DELINEAR-DONNEE)))))

(DE NEXTL-DONNEE ()	;pour avancer dans les donnees linearisees
;                (IFN (EQ (CAR DONNEE) '<<) (NEXTL DONNEE)
                 (IF (NULL (EQ (CAR DONNEE) '<<)) (NEXTL DONNEE)
                      (NEXTL DONNEE)
                      (DELINEAR-DONNEE)))

;les macros-caracteres

(DMC "#" () (CONS '"#" (READ)))	;#X --> (#.X)

(DMC "$" () (CONS '"$" (READ)))	;$X --> ($.X)

(DMC "&" () (CONS '"&" (READ)))	;&X --> (&.X)

;et finalement encore une fois la fameuse fonction LETALL

(DM LETALL CALL
           (LET ((ALIST (EVAL (CADR CALL))))
               (DISPLACE CALL
                   `((LAMBDA ,(MAPCAR ALIST 'CAR) ,@(CDDR CALL))
                        ,@(MAPCAR ALIST (LAMBDA (X) (LIST 'QUOTE (CDR
X))))))))


(pragma "r-" "l-")
;
;  *** Verification procedure for module LISP$_LSQ ***
;

(setq var_info '(1 2 3 4 5 6)   ; List of variable info : name, old value,
                                ; old sigma (unused), Matrix index,
                                ; Related diagonal block and limits block.
      lim_info '(1 2)           ; Limit info inf and sup.
      par_info '(1 2 3)         ; List of parameter info : name, value
                                ; and sigma.
      blk_info '(1 2 3 4 5 6 7) ; List of diagonal block info :
                                ; name, effectives marqward and dampening fac.,
                                ; x and b vector, and matrix,
                                ; first variable.
      lis_info '(1 2 3 4)       ; List of list info :
                                ; name, Current, first element,
                                ; and first parameter.
      col_info '(1 2 3)         ; List of collect info :
                                ; Related list, Reject factor and statistic
                                ; block.
      sta_info '(1 2 3 4 5 6 7  ; statistic info : obs_count
                 8 9 10 11 12 ) ; user and standard chi2,
                                ; sum ( sqr(delta/sigma) ),
                                ; sum ( sqr(delta*weight)),
                                ; sum ( sqr(delta)),
                                ; sum ( abs(delta*weight)),
                                ; sum ( abs(delta)),
                                ; sum ( sqr(obser*weight)),
                                ; sum ( sqr(obser)),
                                ; sum ( abs(obser*weight)),
                                ; sum ( abs(obser)).

)


; *** Change variable procedure ***
(de change_varbl (varbl newval sig shift lim_flg beg_flg end_flg)
  (setq vinfo (sys_call 372 varbl var_info))
  (when beg_flg                       ; for the begin of a diagonal block.
    (setq binfo (sys_call 372 (caddr (cddr var_info)) blk_info))
    (print)
    (print " Diagonal block """ (nextl binfo) """ with Mlc = " (nextl binfo)
           " and Dmp = " (car binfo)
    )

  )
  (prin (nextl vinfo) " = "
        newval ":"
        sig
  )
  (unless end_flg
        (prin ", " (car vinfo)
              ", " shift
          (cond
            ((eq lim_flg 1)  "  *LR*")
            ((eq lim_flg -1) " *MOD*")
            (T               "      ")
          )
 	       ))
  (print)
)

; ***  Singularity Notification Procedure ***
(de signal_sing (varbl nfail ovf_flg)
  (print)
  (prin " *** Singularity on the Variable """
        (car (sys_call 372 varbl var_info)) """")
  (print " => Variable is locked. ")
  (when ovf_flg (sys_call 1 "SING" 14 4))
)

; *** user procedure de/df call entry ***
(de usr_p_call (idx parm)
  ()
)



; *** user function de/df call entry ***
(de usr_f_call (idx parm) (print idx))

; *** user function to cycle begin notification ***
(de usr_beg_cycl (c_nb c_end)
  (print) (print)
  (if c_end
    (progn
      (print "  *** Least-Squares Final Cycle ***")
      (print "  ---------------------------------"))
    (prin  "  *** Least-Squares Cycle #" )
    (o_fixed (4) c_nb) (print " .")
    (print "  -------------------------------"))
  (print)
)

; *** user function to cycle solve notification ***
(de usr_res_cycl (c_nb)
  (print) 
  (usr_end_coll () )
  (print)
  (print)
  (print "     Result of the Least-Squares Cycle #" c_nb " .")
  (print)
)

; *** user function to cycle end notification ***
(de usr_end_cycl (c_nb)
  (print)
  (print "***********************************************************")
  (print)
)

; *** user function to data collection begin notification ***
(de usr_beg_coll (coll)
  (setq curr (sys_call 372 (car (sys_call 372 coll col_info)) lis_info))
  (print)
  (print "    Data Collection """ (car curr) """ ." )
  (print)
  (print)
  (print "   #     X       Y-OBS      YTH      DELTA     SIGMA    WEIGHT    DEL/SIG")
  (print)
)

; *** user function to data collection end notification ***
(de usr_end_coll (coll)
  (setq curr (sys_call 373 coll sta_info))
  (print)
  (if coll
    (progn
      (sys_call 202 the_attr)            ; set computed draw attributs
      (setq seg_curve (sys_call 254 seg_curve curve_liste the_spc)) ; plot the theoric curve.
      (print "     The particular statistic :" )
    )
    (print "     The   Global  statistic  :" ))
  (print "     --------------------------" )
  (print)
  (prin "     Number of used observation         = ")
  (o_fixed (6) (nextl curr)) (print)
  (prin "     User goodness of fit (Chi squared) = ")
  (o_fixed (6 4 1) (nextl curr)) (print)
  (prin "     Standard goodness of fit           = ")
  (o_fixed (6 4 1) (nextl curr)) (print)
  (print)
)

; *** user packet computing function ***
(de usr_pack_cmp (coll nobs obs calc delta sigma weight delssig regflg)
  (o_fixed (4) nobs)
  (o_fixed (10 4 2)  (cadr (sys_call 372 $X par_info))
                     obs calc delta sigma weight delssig)
  (when regflg (prin " *R*"))
  (print)
)

; *** user list element computing function ***
(de usr_listelem_cmp (lis) ()
)



;***************************************
;*                                     *
;*      Define the user language       *
;*                                     *
;***************************************

(input () () "A")

(dma 'cycle ()
  (setq cycle_nb (read))
  (unless (eq word ';) (sys_call 0 "CYCL" 801 2))
)

(dma 'variable ((word ',))
  (while (eq word ',)
    (setq word (list 'quote (read)))            -- get the variable identifier.
    (setq var (list 'sys_call 311 word (read))) -- build the (sys_call 311 ...) 
    (if (null var_curr)
      (setq var_list (cons 'progn (setq var_curr (cons var ()))))
      (rplacd var_curr (cons var ()))
      (setq var_curr (cdr var_curr))
    )
    (setq word (read)) -- get the comma or the semicolon terminator.
  )
  (unless (eq word ';) (sys_call 0 "VARB" 801 2))
)

(dma 'param ((word ',))
  (while (eq word ',)
    (setq word (list 'quote (read)))            -- get the parameter identifier.
-- build :
-- (312 <par_name> '<expression_of_param> <sum_flg> <deriv_flg> <sigma_flg>
--                                                              <cached_flg )
    (setq par (list 312 word (list 'quote (read))  () T T () ))
    (if (null par_curr)
      (setq par_list (cons 'progn (setq par_curr (cons par ()))))
      (rplacd par_curr (cons par ()))
      (setq par_curr (cdr par_curr))
    )
    (setq word (read)) -- get the comma or semicolon terminator.
  )
  (unless (eq word ';) (sys_call 0 "PARM" 801 2))
)

(dma 'weight_shema ()
  (setq weigh_expr (read))
  (unless (eq word ';) (sys_call 0 "WEIG" 801 2))
)

(input () () "L")

;
;****************************************************
;*                                                  *
;*       Initialize the Least-Squares Loader.       *
;*                                                  *
;****************************************************
;

(progn
(sys_call 301
  ; assign the change variable notification entry.
  '(change_varbl varbl newval sig shgift lim_flg beg_flg end_flg)
  '(signal_sing varbl nfail ovf_flg) ; assign the signal singularity entry.
  '(usr_f_call idx parm)             ; assign the user call function entry.
  '(usr_p_call idx parm)             ; assign the user call procedure entry.
  '(usr_beg_cycl c_nb c_end)
  '(usr_res_cycl c_nb)
  '(usr_end_cycl c_nb)
  '(usr_beg_coll coll)
  '(usr_end_coll coll)
  '(usr_pack_cmp coll nobs obs calc delta sigma weight delssig regflg)
  ()
)

;
;****************************************************
;*                                                  *
;*    Build the Least-Squares Control Structure.    *
;*                                                  *
;****************************************************
;

(sys_call 314
         '*BLK_MAIN*     ; Create the Least-Squares matrix Block ".BLK_MAIN.".
         1.0             ; Dampening factor expression.
         1.0             ; Marqward factor expression.
)

;
; ".BLK_MAIN." is now open to get the next following variable.
;

(open 'fctl "I" "sys$input")

(input 'fctl "Fit_Curve> " "A")

(setq var_list () var_curr () par_list () par_curr ())

(setq cycle_nb 1)



(until eof (read))            ; read all param and varbl statement.
(close 'fctl)

(eval var_list)               ; create all user defined variables.


(unless weight_expr (setq weight_expr '(/ 1.0 $SG) )


; Now we define the list of data.

(setq data_dir_list
 '(
     (312 '$X  '(DATA_LIST M_FL  4))  ; Define the current x parameter.
     (312 '$Y  '(DATA_LIST M_FL  8))  ; Define the current y parameter.
     (312 '$SG '(DATA_LIST M_FL 12))  ; Define the current sigma parameter.
  )
      data_dir_end_part
 '(
     (310 $YTH)                       ; push the YTH value to
     (325 DATA_LIST M_FL 20)          ; Store it at 20 offset of current el.

     (310 0)                          ; Push stop scan end condition.
     (310 1)                          ; Push Eligibility condition expression.
  )
)

(nconc data_dir_list (nconc par_list data_dir_end_part))

(sys_call 315 'DATA_LIST              ; Create the data list named "DATA_LIST".
               data_dir_list          ; data directive list.
               0                      ; without cache.
) 


; Now we define the data collection to fit.

(sys_call 316 DATA_LIST               ; the Data collection use the DATA_LIST
                                      ; list to scan the experimental data.
  '(                                  ; Begin of packet directives.

                                      ; End of directive sequence.
    (310 weight_expr )                ; Weight to use,
    (310 '$SG)                        ; Related Y sigma,
    (310 '$Y)                         ; Value to use as experimental Y,
    (310 '$YTH)                       ; Parameter to use as computed value,
    (310 1)                           ; Push sentinel.
  )
  ()                                  ; No cycle directive list.
  1E10                                ; Rejection to use.
)


;
;****************************************************
;*                                                  *
;*    Define the fit related basic directives       *
;*                                                  *
;****************************************************
;

(setq G_STATIS (sys_call 319
  '(                                 ; Define By cycle directive.
     (326 1 '(null T))
   )
  '(                                 ; Define Final directive.
     (312 'AMULB '(* coef_a coef_b) () T T)
   )
))

;
;****************************************************
;*                                                  *
;*    Initialize the Least-Squares processor.       *
;*      And create the running structures.          *
;*                                                  *
;****************************************************
;

(sys_call 302
                 1            ; First cycle #.
                 1            ; Maximum number of tolerate singularities.
                ()            ; Minimal value for a pivot (defaulted).
                ()            ; Normal matrix computing (T => computed at first cycle only).
                ()            ; Final cycle required (T => suppressed).
                 T            ; Correlation matrix required after final cycle.
)

;
;****************************************************
;*                                                  *
;*    Read the Least-Squares Experimental Data.     *
;*                                                  *
;****************************************************
;

(progn
  (setq curve_liste () curr_pt ())
  (print " Open_result = " (open 'f "i" "curve"))
  (input 'f "entree un point s.v.p. ")
  (setq xx (read))                      ; read the first x.
  (until EOF
    (setq yy (read) sgsg (read))        ; read obs. y and sigma.
    (until sys$_read_eoln (read))       ; ignore all trailing data.
    (setq cblk (m_allocb 24))           ; allocate the memory block.
    (m_put (m_offset cblk  4) m_fl xx)  ; set the x value.
    (m_put (m_offset cblk  8) m_fl yy)  ; set the y value.
    (m_put (m_offset cblk 12) m_fl sgsg); set the sg value.
    (if (null curve_liste)              ; if it is the first curve point.
      (setq curve_liste (cons cblk ())  ; then set first curve element.
            curr_pt     curve_liste)    ; else
      (rplacd curr_pt (cons cblk ()))   ;   append the new point
      (nextl curr_pt)                   ;   and set it as last point.
    )
    (setq xx (read))
  )                                     ; end of until.

  (close 'f)

;  (print curve_liste)

; *** plot de la courbe experimentale ***

(sys_call 201 18 15 "Essai de Fit" T)        ; Init du graphic.

(setq exp_spc '( 4   8  ()  () () 12)        ; Set offsets and seg id for exp. curve.
      the_spc '( 4  20  ()  2))              ; Set offsets and seg id for th. curve.
(setq exp_attr '(2  3  4 1.0)                ; Set Attributs (marker,blue,circle,size) for exp.
      sig_attr '(1  1  1 1.0)                ; Set Attributs (line,black,continue,size) for sig.
      the_attr '(1  2  1 2.0))               ; Set Attributs (line,red,continue,size) for th.
(setq minimaxi (sys_call 250 curve_liste exp_spc)) ; comput min-maxi.
(sys_call 251 minimaxi 14 10 2 2 "X" "Y" T)  ; Create the box.

(sys_call 208 1)                             ; define the experimental segment.

(sys_call 202 exp_attr)                      ; set exp. attributs.
(sys_call 254 () curve_liste exp_spc)        ; Plot the experimental curve.

(sys_call 202 sig_attr)                      ; set sigma attributs.
(sys_call 258 () curve_liste exp_spc)        ; Plot the experimental sigma.

(sys_call 238)                               ; start in time of fly mode.


(when (zerop (sys_call 221 "start" )) (fexit "stop"))

(setq seg_curve -1)                          ; the first cycle is flaged by no computed
                                             ; curve segment #.


  (eval (list 'sys_call '331 'DATA_LIST 'curve_liste ) )

; (setq curr_pt curve_liste)
; (until (null curr_pt)
;   (setq cblk (nextl curr_pt))
;   (setq
;     xxx    (m_get (m_offset cblk  4) m_fl)
;     yyy    (m_get (m_offset cblk  8) m_fl)
;     sgsgsg (m_get (m_offset cblk 12) m_fl)
;   )
;    (print "block = " cblk ", x = " xxx ", y = " yyy ", Sigma = " sgsgsg ".") 
; )

;
;****************************************************
;*                                                  *
;*    Run the Least-Squares Processor for 2 Cycles. *
;*                                                  *
;****************************************************
;
  (until (zerop cycle_nb)
    (sys_call 303 cycle_nb)

;
;     Stop before close GKS by a call of dialog.
;
    (sys_call 240)         ; call dialog.

    (setq cycle_nb 0)
    (setq rep (sys_call 221 "autre cycle" 2))
    (when (eq rep 1)
      (setq cycle_nb (sys_call 225 "Nombre de cycle" 1 10 1))
    )
  )

;
;****************************************************
;*                                                  *
;*    Free the Least-Squares running Structures.    *
;*                                                  *
;****************************************************
;

  (sys_call 304)

  (sys_call 200)
)
) ; of progn.

(include "lisp_lib.lisp_lib")

(de expr_undecl (flg)
  (when flg (sys_call 0 "EXPI" 51 3)) ; Undeclared identifier message.
  (list 1 '*const '*int)              ; set defaulted expression.
)

(setq *identifier  '(                 ; * Routine for identifier reference.
                      (if *undef            ; if undeclared then
                        (expr_undecl T)     ; ... error ... else
                        (plist *symb)       ; get the ident. properties list.
                      )
                    )
      *int         '(list *symb '*const '*int)
      *float       '(list *symb '*const '*float)
      *nil         '(list ()    '*const '*string)
      *string      '(list *symb '*const '*string)
      ; To handle the sub-expressions.
      *lpar        '(let ((expr ()))
                      (insymbol)                    ; gobble up "("
                      (setq expr (exp_expression))  ; get the expression.
                      (if (eq *symb '*rpar)
                        (insymbol)                  ; gobble up the ")"
                        (sys_call 0 "EXPR" 58 2))   ; or error.
                    )
      *call_model '(0 1 2 3 4 5 6 7 8 9
                    0 1 2 3 4 5 6 7 8 9
                    0 1 2 3 4 5 6 7 8 9
                    0 1 2)
)



(de insymbol ()
  (setq *symb   (read)
        *undef  sys$_undef
        *kind   (nth sys$_readk '( *nil
                                   *identifier
                                   *list
                                   ()
                                   *int
                                   *float
                                   *string
                                   *string
                                 ))
  )
)

(de expr_ident ()
  (let ((expr (eval *kind)))
    (insymbol)
    (if (memq '*funct (plist expr))
      (expr_call expr)
      expr
    )
  )
)

(de expr_apply lp  ; *** apply an operator at a parameter list.
  (setq *callc *call_model *cteflg T)
  (rplaca *callc (nextl lp))
  (while lp
     (setq *param (nextl lp))
     (when (memq '*const (plist *param)) (setq *cteflg ()))
     (rplaca *callc *param)
     (nextl *callc)
  )
  (if *cteflg
    (eval 
  )
)


(de expr_una () ; *** routine to handle the unary negate operator. ***
  (let ((negflg ())
        (expr   ())
       )
    (while (memq *symb '(+ -))
      (when (eq *symb '-) (setq negflg (null negflg)))
      (insymbol)
    )
    (setq expr
      (if (eq *symb '*lpar)
        (eval *lpar*))
        (expr_ident)              ; obtain a list as (val class type).
      ))
    (if negflg                    ; if use of negate operator
      (expr_apply 'neg expr)      ; apply it...
      expr                        ; ... else return the expression.
    )  
  )
) ; *** end exp_una routine. ***

(progn
  (sys_call 20 "(" *lpar*)
  (sys_call 20 ")" *rpar*)
  (sys_call 20 "-" -)
  (sys_call 20 "+" +)

  (chaine)
  (setq eof ())
  (input () "FORMULA>" "P")
  (insymbol)
  (until eof
    (expression)
    (print "=" expr)
  )
)
(setq obj (m_allocb 136))
(setq i 0)
(m_put (m_offset obj   0) M_UW 136)
(m_put (m_offset obj   2) M_FL 3.1415927)
(m_put (m_offset obj   6) M_LI 1024)
(m_put (m_offset obj  10) "1234567890123456" "alors ca va?")
(m_put (m_offset obj  28) "1234567890123456" "tout va bien.")
(m_put (m_offset obj  46) "1234567890123456" "ok - 00")
(m_put (m_offset obj  64) "1234567890123456" "ok - 01")
(m_put (m_offset obj  82) "1234567890123456" "ok - 02")
(m_put (m_offset obj 100) "1234567890123456" "ok - 03")
(m_put (m_offset obj 118) "1234567890123456" "ok - 04/")
(open 'fil "P" "A.B")
(m_mov obj fil 136)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(m_put (m_offset fil 6) M_LI (incr i))
(put 'fil)
(close 'fil)
(open 'fil "G" "A.B")
(until (eq (get 'fil) sys$_eof)
  (print "li = " (m_get (m_offset fil 6) M_LI)))
(close 'fil)
(%pragma "L+")
(setq
   incl_src_tab (v_create 8 '( (incl_file_0 "MXD_0>")
                               (incl_file_1 "MXD_1>")
                               (incl_file_2 "MXD_2>")
                               (incl_file_3 "MXD_3>")
                               (incl_file_4 "MXD_4>")
                               (incl_file_5 "MXD_5>")
                               (incl_file_6 "MXD_6>")
                               (incl_file_7 "MXD_7>")
                ))
   incl_cnt -1)


(dma 'include
  (
    (incl_ret 0)
    (incl_fspc (read))
    (incl_file (v_index incl_src_tab (incr incl_cnt)))
  )

  (if (<> 0 (setq incl_ret (open (car incl_file) "I" incl_fspc)))
    (sys_call 0 "INCL" (+ 2000 incl_ret) 4)
    (input (car incl_file) (cadr incl_file))
    (read))
)

(dma 'endfile
  ((incl_file (v_index incl_src_tab incl_cnt))
   (tmp_file (v_index incl_src_tab (decr incl_cnt))))
  (if (>= incl_cnt 0)
    (input (car tmp_file) (cadr tmp_file))
    (input))
  (close (car incl_file))
  (read)
)

(%chaine "TT:")
;(pragma "l-")
(include "loop.lisp")
(setq code
  '(progn
    (print "group.")
    {et0
      (prin "> ")
      (setq res (eval (read)))   ; Lisp interpretor.
      (print " result = " res)
      (brkwh (eq sys$_eof res) et0)
    }
  res)
)
(on_error
  (
    (err_code sys$_error)                  ; save the error code.
    (err_sev  (plist 'sys$_error))         ; save the error severity.
    (err_point (plist 'sys$_error_point))  ; save the error point.
  )
  (open 'sys$error "W" "sys$error")
  (output 'sys$error)
  (print " error detected during execution of : ")
  (print err_point)
  (close 'sys$error)
  (sys_call 1 "IT--" err_code err_sev)       ; Output our error message.     
  (cond
    ((> err_code 50) (input) T)              ; for error > 50 standard action.
    ((and (>= err_code 21) (<= err_code 24)) ; for comput error.
      et0)                                   ; goto reprise.
    (T (setq sys$_error_point -1) ()))       ; if other case continue.
  ;   the return value must be :
  ;                        () or NIL to continue execution.
  ;                        T to take the standard action.
  ;                        or a pointer to a restart point.
)
(progn
  (open 'sys$input "I" "sys$input")
  (input 'sys$input " ")
  {main_loop
    (output)
    (brkwh (eq sys$_eof (eval code)) main_loop)
  }
  (print "***fin***")
  (close 'sys$input)
)
(dmc "}" () "}")
(dmc "{" ( (L ()) (C ())                        ; init L and C to nil.
	   (LAB (read))                         ; take this loop label atom.
	   (E (read))                           ; get first object.
         )
	(if (eq E "}") ()                       ; if not empty loop.
		(setq L (list 'progn E))        ; built the begin of loop.
		(setq C (cdr L))                ; init last list elem.
		(set LAB C)                     ; set label for exit macro.
		(until (eq (setq E (read)) "}") ; while E <> "}" do
			(rplacd C (cons E ()))  ;   replace_cdr C, (E);
			(nextl C))              ;   nextl C
		(rplacd C (cdr L))              ; replace_cdr C, LAB
		L))                             ; give L as result.


(eof)

(setq n 1)
(setq prg '{et1
	(print "n = " n ", n2 = " (* n n) ";")
        (brkwh (> (incr n) 10) et1)})

(setq et '(a b c d))
(setq prl '{mai
	(print (nextl et))
	(setq n 1)
	(eval prg)
        (print et)
	(brkunl et mai)
	(prin "..")})

(eval prl)

(chaine)
(pragma "r-" "l-")
;
;  *** Verification procedure for module LISP$_LSQ ***
;

(setq var_info '(1 2 3 4 5 6)   ; List of variable info : name, old value,
                                ; old sigma (unused), Matrix index,
                                ; Related diagonal block and limits block.
      lim_info '(1 2)           ; Limit info inf and sup.
      par_info '(1 2 3)         ; List of parameter info : name, value
                                ; and sigma.
      blk_info '(1 2 3 4 5 6 7) ; List of diagonal block info :
                                ; name, effectives marqward and dampening fac.,
                                ; x and b vector, and matrix,
                                ; first variable.
      lis_info '(1 2 3 4)       ; List of list info :
                                ; name, Current, first element,
                                ; and first parameter.
      col_info '(1 2 3)         ; List of collect info :
                                ; Related list, Reject factor and statistic
                                ; block.
      sta_info '(1 2 3 4 5 6 7  ; statistic info : obs_count
                 8 9 10 11 12 ) ; user and standard chi2,
                                ; sum ( sqr(delta/sigma) ),
                                ; sum ( sqr(delta*weight)),
                                ; sum ( sqr(delta)),
                                ; sum ( abs(delta*weight)),
                                ; sum ( abs(delta)),
                                ; sum ( sqr(obser*weight)),
                                ; sum ( sqr(obser)),
                                ; sum ( abs(obser*weight)),
                                ; sum ( abs(obser)).

)


; *** Change variable procedure ***
(de change_varbl (varbl newval sig shift lim_flg beg_flg end_flg)
  (setq vinfo (sys_call 372 varbl var_info))
  (when beg_flg                       ; for the begin of a diagonal block.
    (setq binfo (sys_call 372 (caddr (cddr var_info)) blk_info))
    (print)
    (print " Diagonal block """ (nextl binfo) """ with Mlc = " (nextl binfo)
           " and Dmp = " (car binfo)
    )

  )
  (prin (nextl vinfo) " = "
        newval ":"
        sig
  )
  (unless end_flg
        (prin ", " (car vinfo)
              ", " shift
          (cond
            ((eq lim_flg 1)  "  *LR*")
            ((eq lim_flg -1) " *MOD*")
            (T               "      ")
          )
 	       ))
  (print)
)

; ***  Singularity Notification Procedure ***
(de signal_sing (varbl nfail ovf_flg)
  (print)
  (prin " *** Singularity on the Variable """
        (car (sys_call 372 varbl varbl_info)) """")
  (print " => Variable is locked. ")
  (when ovf_flg (sys_call 1 "SING" 14 4))
)

; *** user procedure de/df call entry ***
(de usr_p_call (idx param)
  ()
)



; *** user function de/df call entry ***
(de usr_f_call (idx param) (print idx))

; *** user function to cycle begin notification ***
(de usr_beg_cycl (c_nb c_end)
  (print) (print)
  (if c_end
    (progn
      (print "  *** Least-Squares Final Cycle ***")
      (print "  ---------------------------------"))
    (prin  "  *** Least-Squares Cycle #" )
    (o_fixed (4) c_nb) (print " .")
    (print "  -------------------------------"))
  (print)
)

; *** user function to cycle solve notification ***
(de usr_res_cycl (c_nb)
  (print) 
  (usr_end_coll () )
  (print)
  (print)
  (print "     Result of the Least-Squares Cycle #" c_nb " .")
  (print)
)

; *** user function to cycle end notification ***
(de usr_end_cycl (c_nb)
  (print)
  (print "***********************************************************")
  (print)
)

; *** user function to data collection begin notification ***
(de usr_beg_coll (coll)
  (setq curr (sys_call 372 (car (sys_call 372 coll col_info)) lis_info))
  (print)
  (print "    Data Collection """ (car curr) """ ." )
  (print)
  (print)
  (print "   #     X       Y-OBS      YTH      DELTA     SIGMA    WEIGHT    DEL/SIG")
  (print)
)

; *** user function to data collection end notification ***
(de usr_end_coll (coll)
  (setq curr (sys_call 373 coll sta_info))
  (print)
  (if coll
    (progn
      (sys_call 202 the_attr)            ; set computed draw attributs
      (setq seg_curve (sys_call 254 seg_curve curve_liste the_spc)) ; plot the theoric curve.
      (print "     The particular statistic :" )
    )
    (print "     The   Global  statistic  :" ))
  (print "     --------------------------" )
  (print)
  (prin "     Number of used observation         = ")
  (o_fixed (6) (nextl curr)) (print)
  (prin "     User goodness of fit (Chi squared) = ")
  (o_fixed (6 4 1) (nextl curr)) (print)
  (prin "     Standard goodness of fit           = ")
  (o_fixed (6 4 1) (nextl curr)) (print)
  (print)
)

; *** user packet computing function ***
(de usr_pack_cmp (coll nobs obs calc delta sigma weight delssig regflg)
  (o_fixed (4) nobs)
  (o_fixed (10 4 2)  (cadr (sys_call 372 $X par_info))
                     obs calc delta sigma weight delssig)
  (when regflg (prin " *R*"))
  (print)
)

; *** user list element computing function ***
(de usr_listelem_cmp (lis) ()
)

;
;****************************************************
;*                                                  *
;*       Initialize the Least-Squares Loader.       *
;*                                                  *
;****************************************************
;
(sys_call 301
  ; assign the change variable notification entry.
  '(change_varbl varbl newval sig shgift lim_flg beg_flg end_flg)
  '(signal_sing varbl nfail ovf_flg) ; assign the signal singularity entry.
  '(usr_f_call idx param)       ; assign the user call function entry.
  '(usr_p_call idx param)       ; assign the user call procedure entry.
  '(usr_beg_cycl c_nb c_end)
  '(usr_res_cycl c_nb)
  '(usr_end_cycl c_nb)
  '(usr_beg_coll coll)
  '(usr_end_coll coll)
  '(usr_pack_cmp coll nobs obs calc delta sigma weight delssig regflg)
  ()
)

;
;****************************************************
;*                                                  *
;*    Build the Least-Squares Control Structure.    *
;*                                                  *
;****************************************************
;

(sys_call 314
         '*BLK_MAIN*     ; Create the Least-Squares matrix Block ".BLK_MAIN.".
         1.0             ; Dampening factor expression.
         1.0             ; Marqward factor expression.
)
; ".BLK_MAIN." is now open to get the next following variable.
              
(sys_call 311 'coef_a 0)      ; Create the a coefficient Least-Squares variable.

(sys_call 311 'coef_b 0)      ; Create the b coefficient Least-Squares variable.

(sys_call 311 'coef_c 0)      ; Create the c coefficient Least-Squares variable.


; Now we define the list of data.

(sys_call 315 'DATA_LIST ; Create the data list named "DATA_LIST".
  '(
     (312 '$X  '(DATA_LIST M_FL  4))  ; Define the current x parameter.
     (312 '$Y  '(DATA_LIST M_FL  8))  ; Define the current y parameter.
     (312 '$SG '(DATA_LIST M_FL 12))  ; Define the current sigma parameter.
     (312 'YLIN '(+ (* coef_a $X) coef_b) () T T)
     (312 'YTH                        ; define the computed y parameter,
          '(+ (* YLIN $X) coef_c)
                                      ; as a*x^2 + b*x + c,
          ()                          ; It is not a summation parameter,
          T                           ; Derivable parameter,
          T                           ; With computed sigma,
          ()                          ; and no cache use.
     )
     (310 YTH)                        ; push the YTH value to
     (325 DATA_LIST M_FL 20)          ; Store it at 20 offset of current el.

     (310 0)                          ; Push stop scan end condition.
     (310 1)                          ; Push Eligibility condition expression.
   )                                  ; end of list sequence.
  0                      ; without cache.
) 


; Now we define the data collection to fit.

(sys_call 316 DATA_LIST               ; the Data collection use the DATA_LIST
                                      ; list to scan the experimental data.
  '(                                  ; Begin of packet directives.

                                      ; End of directive sequence.
    (310 '(/ 1.0 $SG))                ; Weight to use,
    (310 '$SG)                        ; Related Y sigma,
    (310 '$Y)                         ; Value to use as experimental Y,
    (310 'YTH)                        ; Parameter to use as computed value,
    (310 1)                           ; Push sentinel.
  )
  ()                                  ; No cycle directive list.
  1E10                                ; Rejection to use.
)


;
;****************************************************
;*                                                  *
;*    Define the fit related basic directives       *
;*                                                  *
;****************************************************
;

(setq G_STATIS (sys_call 319
  '(                                 ; Define By cycle directive.
     (326 1 '(null T))
   )
  '(                                 ; Define Final directive.
     (312 'AMULB '(* coef_a coef_b) () T T)
   )
))

;
;****************************************************
;*                                                  *
;*    Initialize the Least-Squares processor.       *
;*      And create the running structures.          *
;*                                                  *
;****************************************************
;

(sys_call 302
                 1            ; First cycle #.
                 1            ; Maximum number of tolerate singularities.
                ()            ; Minimal value for a pivot (defaulted).
                ()            ; Normal matrix computing (T => computed at first cycle only).
                ()            ; Final cycle required (T => suppressed).
                 T            ; Correlation matrix required after final cycle.
)

;
;****************************************************
;*                                                  *
;*    Read the Least-Squares Experimental Data.     *
;*                                                  *
;****************************************************
;

(progn
  (setq curve_liste () curr_pt ())
  (print " Open_result = " (open 'f "i" "curve"))
  (input 'f "entree un point s.v.p. ")
  (setq xx (read))                      ; read the first x.
  (until EOF
    (setq yy (read) sgsg (read))        ; read obs. y and sigma.
    (until sys$_read_eoln (read))       ; ignore all trailing data.
    (setq cblk (m_allocb 24))           ; allocate the memory block.
    (m_put (m_offset cblk  4) m_fl xx)  ; set the x value.
    (m_put (m_offset cblk  8) m_fl yy)  ; set the y value.
    (m_put (m_offset cblk 12) m_fl sgsg); set the sg value.
    (if (null curve_liste)              ; if it is the first curve point.
      (setq curve_liste (cons cblk ())  ; then set first curve element.
            curr_pt     curve_liste)    ; else
      (rplacd curr_pt (cons cblk ()))   ;   append the new point
      (nextl curr_pt)                   ;   and set it as last point.
    )
    (setq xx (read))
  )                                     ; end of until.

  (close 'f)

;  (print curve_liste)

; *** plot de la courbe experimentale ***

(sys_call 201 18 15 "Essai de Fit" T)        ; Init du graphic.

(setq exp_spc '( 4   8  ()  () () 12)        ; Set offsets and seg id for exp. curve.
      the_spc '( 4  20  ()  2))              ; Set offsets and seg id for th. curve.
(setq exp_attr '(2  3  4 1.0)                ; Set Attributs (marker,blue,circle,size) for exp.
      sig_attr '(1  1  1 1.0)                ; Set Attributs (line,black,continue,size) for sig.
      the_attr '(1  2  1 2.0))               ; Set Attributs (line,red,continue,size) for th.
(setq minimaxi (sys_call 250 curve_liste exp_spc)) ; comput min-maxi.
(sys_call 251 minimaxi 14 10 2 2 "X" "Y" T)  ; Create the box.

(sys_call 208 1)                             ; define the experimental segment.

(sys_call 202 exp_attr)                      ; set exp. attributs.
(sys_call 254 () curve_liste exp_spc)        ; Plot the experimental curve.

(sys_call 202 sig_attr)                      ; set sigma attributs.
(sys_call 258 () curve_liste exp_spc)        ; Plot the experimental sigma.

(sys_call 238)                               ; start in time of fly mode.


(when (zerop (sys_call 221 "start" )) (fexit "stop"))

(setq seg_curve -1)                          ; the first cycle is flaged by no computed
                                             ; curve segment #.


  (eval (list 'sys_call '331 'DATA_LIST 'curve_liste ) )

; (setq curr_pt curve_liste)
; (until (null curr_pt)
;   (setq cblk (nextl curr_pt))
;   (setq
;     xxx    (m_get (m_offset cblk  4) m_fl)
;     yyy    (m_get (m_offset cblk  8) m_fl)
;     sgsgsg (m_get (m_offset cblk 12) m_fl)
;   )
;    (print "block = " cblk ", x = " xxx ", y = " yyy ", Sigma = " sgsgsg ".") 
; )

;
;****************************************************
;*                                                  *
;*    Run the Least-Squares Processor for 2 Cycles. *
;*                                                  *
;****************************************************
;

  (sys_call 303 2)

;
;****************************************************
;*                                                  *
;*    Free the Least-Squares running Structures.    *
;*                                                  *
;****************************************************
;

  (sys_call 304)

;
;     Stop before close GKS by a call of dialog.
;
  (sys_call 240)

  (sys_call 200)
(print "end of fit.")
)
;*************************************************************************
;**************     Least-Squares Objects Definitions    *****************
;*************************************************************************
;*                                                                       *
;*                                                                       *
;*    For all least-squares objects :                                    *
;*                                                                       *
;* Address offset   Field         Lisp          comments                 *
;*    for Lisp      name       Descriptor                                *
;*                                                                       *
;*                                                                       *
;*                                                                       *
;* diagonal block structure :                                            *
;* --------------------------                                            *
;*                                                                       *
;*   ->   0 /     blk_dmp         M_AD   -Static dampening factor value  *
;*        4 /     blk_dyn         M_OB   -Dynamic dampening factor def.  *
;*        8 /     blk_name        M_OB   -Diagonale block atome name ptr.*
;*       12 /     blk_link        M_AD   -Link to next diagonal block.   *
;*       16 /     blk_varbl       M_AD   -Link to first variable of block*
;*       20 /     blk_size        M_LI   -Diagonal block size.           *
;*                                ( size = 24 )                          *
;*                                                                       *
;*                                                                       *
;* variable struture :                                                   *
;* -------------------                                                   *
;*                                                                       *
;*   ->   0 /     var_value       M_FL   -Current variable value.        *
;*        4 /     var_sigma       M_FL   -Last variable sigma.           * 
;*        8 /     var_lower       M_FL   -Lower limit.                   *
;*       12 /     var_upper       M_FL   -Upper limit.                   *
;*       16 /     var_index       M_SW   -Variable matrix index.         *
;*       18 /     var_flag        M_UW   -Variable flag.                 *
;*       20 /     var_name        M_OB   -Variable name (atom pointer).  *
;*       24 /     var_link        M_AD   -Variable link.                 *
;*                                ( size = 28 )                          *
;*                                                                       *
;*                                                                       *
;* parameter struture :                                                  *
;* --------------------                                                  *
;*                                                                       *
;*   ->   0 /     par_value       M_FL   -Last value.                    *
;*        4 /     par_sigma       M_FL   -Last sigma.                    *
;*        8 /     par_definition  M_OB   -Parameter definition.          *
;*       12 /     par_lstder      M_AD   -List of parameter derivate blk.*
;*       16 /     par_name        M_OB   -Parameter name (atom pointer). *
;*       20 /     par_link        M_AD   -Parameter link.                *
;*                                ( size = 24 )                          *
;*                                                                       *
;* derivate block :                                                      *
;* ----------------                                                      *
;*                                                                       *
;*   ->   0 /     der_link        M_AD   -pointer to the next der. block *
;*        4 /     der_varbl       M_AD   -pointer to the related variable*
;*        8 /     der_value       M_FL   -last derivate value            *
;*       12 /     der_kind        M_LI   -kind of variable for derivate. *
;*                                                                       *
;*                                                                       *
;*                                                                       *
;* list definition block :                                               *
;* -----------------------                                               *
;*                                                                       *
;*   ->   0 /     lis_current     M_AD   -pointer to current element.    *
;*        4 /     lis_first       M_AD   -pointer to the first elem.     *
;*        8 /     lis_last        M_AD   -pointer to the last elem.      *
;*       12 /     lis_param       M_AD   -pointer to the attached parm.  *
;*       16 /     lis_descr       M_OB   -pointer to the lisp descriptor.*
;*                                                                       *
;*                                                                       *
;*                                                                       *
;*                                                                       *
;*************************************************************************
;
(dma 'record                 ; define the record constructor.
  ; local definitions/assignations.
  ((rec_size 0)
   (type_name (read))
   (field_name ())
   (field_type ())
  )
  ; dma (LET like) body.
  (lex_level type_name)
  { record_def_loop
    (setq field_name (read))
    (brkwh (eq field_name 'end) record_def_loop)
    (setq field_type (read))
    ()
  }
)
(dma '%include
  ()
  (include (read))
  (read)
)

(dma '%chaine
  ()
  (chaine (read))
)

(dma '%eof
  ()
  (chaine (eof))
)

(dm mcons1 l
	(if (null (cddr l)) (cadr l)
		`(cons ,(cadr l) (mcons1 ,@(cddr l)))))
(chaine)
(progn
  ;  *** here we set the PASCAL string mode for input ***
  (typech "'" (typech """" ()))


  ; *** disable all LISP macro character ***

  (typech "(" '(() *lpar*) )
  (typech ")" '(() *rpar*) )
  (typech "[" '(() *bra*) )
  (typech "]" '(() *ket*) )
  (typech "`" ())

  (dmc ":" ((nch (peekch)))
    (cond
      ((= "=" nch) (readch) '*assign*)
      (T '*colon*)
    )
  )

  (dmc ";" () '*semicolon*)
  (dmc "," () '*comma*)

  ;  enable MXD/PASCAL separator and operator.

  (dmc "^" () '*power*)
  (dmc "*" ((nch (peekch)))
    (cond
      ((= "*" nch) (readch) '*power*)
      (T  '*mulop*)
    )
  )
  (dmc "/" () '*divop*)
  (dmc "+" () '*addop*)
  (dmc "-" () '*subop*)
  (dmc "=" () '*eq*)
  (dmc ">" ((nch (peekch)))
    (cond
      ((= "=" nch) (readch) '*ge*)
      (T '*gt*)
    )
  )
  (dmc "<" ((nch (peekch)))
    (cond
      ((= "=" nch) (readch) '*le*)
      ((= ">" nch) (readch) '*ne*)
      (T '*lt*)
    )
  )
  (dmc "&" () '*and*)
  (dmc "!" ((nch (peekch)))
    (cond
      ((= "!" nch) (readch) '*concat*)
      (T  '*ior*)
    )
  )

  (setq top_lex 2)                       ; extablish the standard lex.
  (sys_call  10   'MXD_V4_SDT)           ; establish the standard lex_level.
  (sys_call  11    2 0 2)                ; as the unique lex tevel.
                                             

  (sys_call 10  'pragma_def)             ; define the pragma options.
  (setq
    L '(Sign Nint)
    F '(Nint Nint)
    D '(Sign)
  )
  (sys_call 12)                          ; deactivate it.



  (dma (implodech "pragma")              ; define the include macro.
    ((prag_opt (read))
    {prag_et0

      (brkunl (eq (insymbol) '*comma*) pragma_et0)
      (insymbol)
    }
    (unless (eq symb '*semicolon*)
      (sys_call 0 "PRAG" 1006 3))
  )



  (dma (implodech "include")             ; define the include macro.
    ()

  )

  (dma (implodech "chaine")              ; define the include macro.
    ()
  )

  (dma (implodech "endfile")             ; define the include macro.
    ()
    (eof)                                ; perform an eof of the source.
  )

;// variable statement algorithm.

  (dma (implodech "variable")            ; it is a run time created atom.   
    ; body.
    { VARBL_ET
      (NEW_IDE 0.0 "F" )
      ;
      ;  create the VARIABLE entity here.
      ;
      (setq varbl (m_allocb 16))             ; creat the variable allocation.
      (when (eq symb '*EQ*)                  ; if = then ...
        (progn (INSYMBOL)                    ; gobble it ...
          (m_put varbl M_FL (R_EXPR))        ; set cte expression value.
          (when (eq symb '*colon*)           ; if ":" seen then
            (m_put (m_offset varbl 4) M_FL (R_EXPR)) ; set the sigma.
          )))
      (when (eq symb '*in*)                  ; range specification.
        (progn (INSYMBOL)                    ; gobble up in ...
          (m_put (m_offset varbl 8) M_FL (R_EXPR))  ; set the low limit,
          (m_put (m_offset varbl 12) M_FL (R_EXPR)) ; and the high limit.
        ))
      (brkunl (eq symb '*comma*) VARBL_ET)   ; Go out if not a comma.
    }
  )

;// limits statement algorithme.

  (dma 'limits
    ; local variables .
    ()
    ; body.

  )

;// fixed statement algorithme.

  (dma (implodech "fixed")
    ; local variables .
    ()
    ; body.

  )

;// unfixed statement algorithme.

  (dma (implodech "unfixed")
    ; local variables .
    ()
    ; body.

  )

;// param statement algorithme.

  (dma (implodech "param")
    ; local variables .
    ()
    ; body.

  )

;// data statement algorithme.

  (dma (implodech "data")
    ; local variables .
    ()
    ; body.

  )




  ; ************ set the user lex level *************

  (sys_call  10    'MXD_USER_LEVEL)
  (sys_call  11     ()                       ; search top is the top lex,
                     2                       ; basis is the standard lex,
                    ()                       ; allocation is the top lex,
                     2 )                     ; standard lex is reserved.
  (incr top_lex)

)                                            ; end of init code.
(pragma "R-" "C-" "T-")
(include "[appl]macro_loop.lisp" "L-")
(setq
  *power* '(*pow* **)
  *mulop* '(*mul* *)
  *divop* '(*mul* /)
  *addop* '(*add* +)
  *subop* '(*add* -)
  *conca* '(*add* s_concat)
  *eq*    '(*rel* =)
  *ne*    '(*rel* <>)
  *lt*    '(*rel* <)
  *le*    '(*rel* <=)
  *ge*    '(*rel* >=)
  *gt*    '(*rel* >)
  *notop* '(*not* null)
  *andop* '(*and* &)
  *iorop* '(*ior* !)
)
;
; source error procedure.
;
(de ERROR (cd sv md)
  (syscall 0 cd sv md)                    ; basic system error call.
)
;
;  insymbol procedure.
;
(de INSYMBOL ()
  (setq symb (read))
)
;
;;
;;  operator definitions.
;;
;
; unary evaluation operator function
;
(de EVL_UNA (ope obj)
  (print "EVL_UNA : " ope ":" obj)        ;*Debug print.
  (if (eq "L" (car (cddr obj)))           ; if literal value then.
    (setq EVL_UNA (apply ope (car obj)))  ; apply this operator.
    (setq EVL_UNA (list ope obj))         ; else create the operative list.
    (rplaca (cddr EVL_UNA) "V"))          ; flag with the variable attribut.
  EVL_UNA
)
;
; binary evaluation operator function.
;
(de EVL_BIN (ope obj1 obj2)
  (print "EVL_BIN : " ope ":" obj1 ", " obj2)
  (if (and (eq "L" (car (cddr obj1)))     ; if two literal values then.
           (eq "L" (car (cddr obj2))))
    (setq EVL_BIN (apply ope (car obj1) (car obj2))); apply this operator.
    (setq EVL_BIN (list ope obj1 obj2))   ; else create the operative list.
    (rplaca (cddr EVL_BIN) "V"))          ; flag for variable attr.
  EVL_BIN
)
;
;  expression identifier procedure.
;
(de EXP_IDENT ()
  (cond
    ((eq 0 sys$_readk)                    ; nil for empty string.
      (setq exp_obj '(() "S" 0 "L")))     ; set null string attribute.

    ((eq 1 sys$_readk)                    ; atom case.
      (if sys$_undef                      ; if undeclared identifier.
        (progn (ERROR 51 3 ())            ; then error ...
          (setq exp_obj '(() "U" 0 "L"))) ; and set default declaration.
        (setq exp_obj symb)))             ; else, get identifier information.

    ((eq 4 sys$_readk)                    ; Integer const.
      (setq exp_obj (cons symb '("I" 4 "L"))))

    ((eq 5 sys$readk)                     ; Floatting constant.
      (setq exp_obj (cons symb '("F" 4 "L"))))

    ((eq 6 sys$_readk)                    ; Character constant.
      (setq exp_obj (cons symb '("C" 1 "L"))))

    ((eq 7 sys$readk)                     ; String constant.
      (setq exp_obj (cons symb '("S" 0 "L"))))

    (T (ERROR 53 3 ())
      (setq exp_obj '(() "U" 0 "L")))     ; otherwise error.
  )
  (INSYMBOL)                              ; get the next symbol.
)
;
; Unary operator procedure.
;
(de EXP_UNA ()
  (setq exp_neg ())                       ; set none negative flag.
  (while (or (eq symb '*addop*)           ; while positif or negative
             (eq symb '*subop*))          ; sign loop.
         (when (eq symb '*sub*)           ; if negative signe then
           (setq exp_neg (null exp_neg))) ; then reverse the negative flag.
         (INSYMBOL))                      ; ... read the next syntax unit.
  (if (eq symb '*lpar*)                   ; if "(" then ...
    (progn (INSYMBOL)                     ; gobble up,
      (EXPRESSION)                        ; get the expression, and
      (if (eq symb '*rpar*) (INSYMBOL)    ; if ")" then  gobble up,
        (ERROR 60 3 ())))                 ; else error...
                                          ; no "( exp )" case
    (EXP_IDENT)                           ; get the expression symbol.
    (setq exp_more T)                     ; set the continue flag.
    (while exp_more                       ; loop until end of specifier...
      (cond
        ((eq symb '.) (INSYMBOL)          ; record field case.
          (EXP_FIELD))
        ((eq symb '*bra*) (INSYMBOL)      ; array element ref. case.
          (EXP_INDEX))
        (T (setq exp_more ()))            ; otherwise => stop the while loop.
      )))
  (when exp_neg                           ; when negative flag applied it.
    (setq exp_obj  (EVL_UNA 'neg exp_obj)))  ;
  exp_obj                                 ; set the EXP_UNA result.
)
;
; power function.
;
(de EXP_POW ()
  (setq EXP_POW (EXP_UNA))                    ; get the main term.
  (when (eq (car (setq exp_op symb)) '*power*); if it is a power operator then
    (INSYMBOL)
    (setq EXP_POW (EVL_BIN (cdr exp_op) EXP_POW (EXP_UNA)))) ; perform the operation.
  EXP_POW
)
;
; mul and div function.
;
(de EXP_MUL ()
  (setq EXP_MUL (EXP_POW))                    ; get the term.
  (when (eq (car (setq exp_op symb)) '*mul*)  ; if it is a power operator then
    (INSYMBO

     (setq EXP_MUL (EVL_BIN (cdr exp_op) EXP_MUL (EXP_POW)))) ; perform the operation.
  EXP_MUL
)
;
; add sub function.
;
(de EXP_ADD ()
  (setq EXP_ADD (EXP_MUL))                    ; get the factor.
  (when (eq (car (setq exp_op symb)) '*add*)  ; if it is a power operator then
    (INSYMBOL)
    (setq EXP_ADD (EVL_BIN (cdr exp_op) EXP_ADD (EXP_MUL)))) ; perform the operation.
  EXP_ADD
)
;
; relation function.
;
(de EXP_REL ()
  (setq EXP_REL (EXP_ADD))                    ; get the factor.
  (when (eq (car (setq exp_op symb)) '*rel*)  ; if it is a relation then
    (INSYMBOL)
    (setq EXP_REL (EVL_BIN (cdr exp_op) EXP_REL (EXP_ADD)))) ; perform the operation.
  EXP_REL
)
;
; not class function.
;
(de EXP_NOT ()
  (setq EXP_NOT (EXP_REL))                    ; get the factor.
  (when (eq (car (setq exp_op symb)) '*not*)  ; if it is a relation then
    (INSYMBOL)
    (setq EXP_NOT (EVL_UNA (cdr exp_op) EXP_NOT))) ; perform the operation.
  EXP_NOT
)
;
; and class function.
;
(de EXP_AND ()
  (setq EXP_AND (EXP_NOT))                    ; get the factor.
  (when (eq (car (setq exp_op symb)) '*and*)  ; if it is a relation then
    (INSYMBOL)
    (setq EXP_AND (EVL_BIN (cdr exp_op) EXP_AND (EXP_NOT)))) ; perform the operation.
  EXP_AND
)
;
; or class function function. // it is the basic expression function ///.
;
(de EXPRESSION ()
  (setq EXPRESSION (EXP_AND))                 ; get the factor.
  (when (eq (car (setq exp_op symb)) '*ior*)  ; if it is a relation then
    (INSYMBOL)
    (setq EXPRESSION (EVL_BIN (cdr exp_op) EXPRESSION (EXP_AND)))) ; perform the operation.
  (setq exp_obj (EXPRESSION))
)
;
;   ERROR procedure.
;
(de ERROR (modul subject cod)
  (print " FIT-ERROR " modul """" subject """ for reason " (abs cod) " .")
;  (sys_call 0) 
  (unless (>= 0 cod) (fexit " Stop FIT."))
)
;
;   get a cte value procedure.
;
(de RC_EXPR ()
()
)
;
;   get a cte string procedure.
;
(de ST_EXPR ()
()
)
;
;   get a physical value procedure.
;
(de PH_EXPR ()
()
)
;
; object declaration procedure.
;
(de NEW_IDE (val kind sz attr lide)
; (sys_call top_lex 2 top_lex 2)        ; set default declaration lex to top.
  (INSYMBOL)                             ; Get the next field.
  (when (eq SYS$_READK 4)                ; if it is an integer const.
    (setq symb (+ 2 symb))               ; lex translated in lisp lex.
    (when (< symb 3) (setq symb 3))      ; limit in range 3..top_lex.
    (when (> symb top_lex) (setq symb top_lex))
    (lex_level symb 2 symb)              ; set the allocation lex.
    (INSYMBOL))                          ; read the id name.
  (when (<> SYS$_READK 1)                ; if it is not an atom
      (error 32 3 ()))                   ; error: expected an atom name.
  (when (null SYS$_UNDEF)                ; if already exist
    (if (null symb)                      ; reserved word ?
      (error 99 3 ())                    ; error: illegal reserved word.
      (error 33 3 ())))                  ; error: declared twice.
  (lex_level top_lex 2 top_lex)          ; restore the normal lex mode.
)
;
;
;
;
;  statement procedure.
;
(de STATEMENT ()                             ; no parameters.
  (print "stat =" (setq stat (read)))        ; read a syntax unit.
  (cond
    ((eq stat 'variable)
    )
    ((eq stat 'param)
    )
    (T (error 99 3 ()))
  )
)



;
;   FIT main program.
;
(setq lst_file "FIT.LIST")
(setq src_file "FITSRC")
(progn                                       ; we must read all in one time.
  (include "MXD$INIT.LISP" "L+:2")           ; initalize the read system.

  (setq err (open 'lst "N" lst_file 55))     ; open the source file (55l/pg.).
  (unless (= 0 err)                          ; signal open error.
    (print "Cannot open listing file """ lst_file """ for reason " err " .")
    (fexit " Stop FIT."))
  (setq err (open 'src "R" src_file 1))      ; set src as source line.
  (unless (= 0 err)                          ; signal open error.
    (print "Cannot open source file """ src_file """ for reason " err " .")
    (fexit " Stop FIT."))

  (output 'lst )                             ; selection of listing file.
;             ()     ;                       ; no line size specified.
;             55     ;                       ; 55 lines by page.
;             ()     ;                       ; no print at close time.
;             )      ;                       ; and no margin.

  (list_head 'lst " MXD_V4.0 Compiler - P. WOLFERS Software 15-SEPT-1990.")

  (input 'src "LISP_FIT>" "P")               ; select src file set the prompt
                                             ; and the PASCAL comment mode.
  (pragma "L+")                              ; set the source listing .

  (FIT_INIT)                                 ; initialize the fit process.



  ; ********** main read loop  **********

  { E_EXIT                                   ; loop label exit.
    (brkwh (eq sys$_eof (STATEMENT))  E_EXIT)     ; loop exit condition.
  }                                          ; end of main loop.
  (typech """" (typech "'" save_quote))      ; restore quot and ".
  (typech "(" save_lparen)
  (typech ")" save_rparen)
  (typech "[" save_lbra)
  (typech "]" save_rbra)
  (typech "`" save_backq)

  (input)                                    ; return to lisp mode.
  (close 'src)                               ; and close source file.
)
(de insymbol ()
  (setq *symb (read)
        *undef sys$_undef
        *kind  sys$_readk)
)

(progn
  ; *** Define the separators ***
  (sys_call 20 "(" (() "(")) ; Open parenthesis.
  (sys_call 20 ")" (() ")")) ; Close parenthesis.
  (sys_call 20 "," (() ",")) ; Comma.
  (sys_call 20 ";" (() ";")) ; Semicolon.

  ; *** Define the operators ***
  (sys_call 20 "^" ((2 6 2 () () **)))   ; x ^ y.
  (sys_call 20 "*" ((2 5 2 () ()  *))    ; x Multiply y.
               "*" ((2 6 2 () () **)))   ; x ^ y.
  (sys_call 20 "-" ((1 7 1 () () neg)    ; - x.
                    (2 4 2 () ()  -)))   ; x - y.
  (sys_call 20 "/" ((2 5 2 () 1.0 /)))   ; x / y.
  (sys_call 20 "+" ((2 4 2 () 1.0 +)))   ; x + y.

  (sys_call 20 "=" ((2 3 2 () 1   =)))   ; x = y.
  (sys_call 20 "<" ((2 3 2 () 1   <))    ; x < y.
            20 "=" ((2 3 2 () 1  <=))    ; x <= y.
            20 ">" ((2 3 2 () 1  <>)))   ; x <> y.
  (sys_call 20 ">" ((2 3 2 () 1   >))    ; x > y.
            20 "=" ((2 3 2 () 1  >=)))   ; x >= y.

  (sys_call 20 "&" ((2 2 2 () 1 and)))   ; x & y.
  (sys_call 20 "!" ((2 1 2 () 1  or)))   ; x ! y.

  ; *** use expression ***

;  (pragma "T+" "C+")

  (setq eof ())
  (chaine)
  (input () "EXPR>" "P")
  (insymbol)
  (print *symb *undef *kind)
  (until eof
     (print *symb *undef *kind)
     (insymbol)
  )
)

;
; macro to create a record type.
;
(dma 'record
  (
    (rec_blk (read))
    (rec_curr ())
    (rec_ftype ())
    (rec_size 0))
  (setq rec_curr (cdr rec_blk))
  (setplist (car rec_blk) rec_blk)
  (while rec_curr
    (setq rec_ftype (cdr (nextl rec_curr)))
    (rplacd rec_ftype (cons rec_size (cdr rec_ftype)))
    (setq rec_size (+ rec_size (m_size (car rec_ftype))))
  )
  (rplaca rec_blk (cons '*size* rec_size))
  'rec_blk
)

;
; macro to create a new record from a defined type.
;
(dma new_record
  ( (rec_obj (read))
    (rec_spc (read))
    (rec_curr ())
    (rec_field ())
  )
  (setplist rec_obj (plist (nextl rec_spc)))
  (set rec_obj (m_allocb (getprop rec_obj '*size*)))
  (setq rec_curr (cdr (plist rec_obj)))
  (while (and rec_curr rec_spc)
    (setq rec_field (nextl rec_curr))
    (m_put (m_offset rec_obj (cadr rec_field)) (caddr rec_curr) (nextl rec_spc))
  )
)


;
;  Create a MXD Variable Record.
;
record (variable
  (curval M_FL 8 4)       ; current value.
  (cursig M_FL 8 4)       ; current sigma.
  (v_name "12345678901234567") : variable name.
  (inflim M_FL 6 2)       ; inf value.
  (suplim M_FL 6 2)       ; sup value.
  (matind M_UW 6))        ; matrix index.

(plist 'variable)


(setq current_lex 1      ; pur les essais.
      reserved_lex 0)

;
; get a syntax unit routine.
;
(de insymbol ()
  (setq symb (read))
)

;
; identifier creation routine.
;
(de decl_ident (lex)
  ; set the current lex as unique.
  (sys_call 11 lex lex lex reserved_lex)
  (insymbol)
  (when (<> sys$_readk 1)
    (sys_call 0 "NWID" 1053 2))   ;;; An identifier was expected.
  (when (null sys$_undef)
    (sys_call 0 "NWID" 1052 2))   ;;; Identifier declared twice
                                  ;;; or was a reserved keyword.
  ; set the normal lex handling.
  (sys_call 11 current_lex 0 current_lex reserved_lex)
)

;
; create a record type.
;
(dma (implodech "record")
  (
    (rec_lex (1+ current_lex))
    (rec_typ)
    (rec_def)
    (rec_curr)
    (rec_ftype)
    (rec_size 0)
    (rec_save1 (typech "(" '(() "(")))   ; disable "("
    (rec_save2 (typech ")" '(() ")")))   ; and ")", the list macro char.
  )
  ; set current lex for creation of new type.
  (sys_call 10 rec_typ)                  ; creates the record attached lex.
  (1+ current_lex)
  ; set current lex for creation of field identifiers.

  (sys_call 11 current_lex current_lex current_lex reserved_lex)
  (setq rec_def (read))
  (1- current_lex)
  ; set current lex for operation.
  (sys_call 12)                          ; deactivates the record lex.
  (sys_call 11 current_lex 0 current_lex reserved_lex)
  (setplist rec_typ rec_def)
  (setq rec_curr rec_def)
  (while rec_curr
    (setq rec_ftype (cdr (nextl rec_curr)))
    (rplacd rec_ftype (cons rec_size (cdr rec_ftype)))
    (setq rec_size (+ rec_size (m_size (car rec_ftype))))
  )
  (rplaca rec_def (cons '*size* rec_size))
  'rec_def
)
  
;
; macro to create a new record from a defined type.
;
(dma new_record
  ( (rec_obj (read))
    (rec_spc (read))
    (rec_curr ())
    (rec_field ())
  )
  (setplist rec_obj (plist (nextl rec_spc)))
  (set rec_obj (m_allocb (getprop rec_obj '*size*)))
  (setq rec_curr (cdr (plist rec_obj)))
  (while (and rec_curr rec_spc)
    (setq rec_field (nextl rec_curr))
    (m_put (m_offset rec_obj (cadr rec_field)) (caddr rec_curr) (nextl rec_spc))
  )
)


;
;  Create a MXD Variable Record.
;
record (variable
  (curval M_FL 8 4)       ; current value.
  (cursig M_FL 8 4)       ; current sigma.
  (v_name "12345678901234567") : variable name.
  (inflim M_FL 6 2)       ; inf value.
  (suplim M_FL 6 2)       ; sup value.
  (matind M_UW 6))        ; matrix index.

(plist 'variable)


(include "lispsrc:trl.lisp")
(chaine)
(pragma "l-" "r-")
(de es ()
  (PRINt " entrez le nombre de points a traiter ")
  (setq ok ())
  (while (equal ok ())
         (setq nbp (read))
         (print "etes vous sur que le nbr de points soit:"nbp"[y/n]")
         (setq i (read))
         (if (equal i 'y) (setq ok t)
                          (print "recommencer"))
  (print  "le nbr de points est:"nbp)
  (print "a suivre") 
  )

(chaine "tt:")

(open 'lisp_lisp "N" "LISP.TRACE")
(SETQ LISP_FLAG nil)

(dmc "^" () (cond
		((NULL LISP_FLAG)
			(SETQ LISP_FLAG T)
			(PRINT "File output mode.")
			(OUTPUT 'lisp_lisp  128 55 T)
                        (PRINCH "-" 70))
		( T (SETQ LISP_FLAG NIL)
			(OUTPUT)
			(PRINT "Terminal Output Set."))
	    )
)

"_^_loaded"
(dmc "\" () (close 'lisp_lisp))
; case in Lisp with the vector use.

(setq case_table (v_create 12    ; create a vector with 12 element.
  '( dest__1                     ; case directions table.
     dest__2
     dest__3
     dest__4
     dest__6
     dest__7
     dest__8
     dest__9
     dest_10
     dest_11
     dest_12
   )
   'default_dest
))

(eval (v_index case_table selector otherwise) )
(v_case case_table selector otherwise)
(open 'f "E" 'txt)
(pragma "r-")
(output 'f)
(setq n 0)
;(setq pri$_str """")
(while (< n 10) (print " n =" n ", n^2 =" (** n 2)) (setq n (1+ n)))
(output)
(close 'f)
(setq pri$_str ())
(pragma "r+")
txt
(open 'f "S" txt)
(setq pri$_str """")
(progn
  (input 'f)
  (until (eq sys$_eof (setq line (read))) (print line))
  (input)
  (close 'f)
)
